package nc.ui.arap.actions;

import java.awt.event.ActionEvent;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.swing.Icon;
import javax.swing.JFileChooser;
import javax.swing.KeyStroke;

import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.pub.bill.BillModel;

import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.pub.templet.converter.util.helper.ExceptionUtils;
import nc.sfbase.client.ClientToolKit;
import nc.ui.arap.view.ArapBillCardForm;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pub.report.ReportBaseClass;
import nc.ui.pubapp.uif2app.actions.BodyAddLineAction;
import nc.vo.arap.payable.PayableBillItemVO;

/**
 * 
 * @author YY
 *
 */
public class ImportBodyAction extends BodyAddLineAction{
	private IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private final static long serialVersionUID = 3494691988067685023L;
	private ArapBillCardForm editorModel;
	private JFileChooser m_chooser = null;
	private ReportBaseClass tp;
	private Icon icon = ClientToolKit.loadImageIcon("\\themeroot\\blue\\themeres\\ui\\toolbaricons\\template.png");
	private int rowCount = 0;
	public ArapBillCardForm getEditorModel() {
		return editorModel;
	}

	public void setEditorModel(ArapBillCardForm arapBillCardForm) {
		this.editorModel = arapBillCardForm;
	}

	public static long getSerialversionuid() {
		return serialVersionUID;
	}

	public ImportBodyAction(){
		setCode("importbodyaction");
		setBtnName("");
		setName("");
		putValue("AcceleratorKey", KeyStroke.getKeyStroke(82, 8));
		setShowNameInToolbar(true);
		setIsShow(true);
		putValue("ShortDescription", "");
		putValue("SmallIcon", icon);

	}
	/**
	 * ļѡ
	 *
	 * @author conn
	 * @return
	 * @return JFileChooser
	 * @date 2019-9-10
	 */
	public JFileChooser getChooser() {
		if (m_chooser == null) {
			m_chooser = new JFileChooser();
			m_chooser.setDialogType(JFileChooser.SAVE_DIALOG);
		}
		return m_chooser;
	}


	@Override
	public void doAction(ActionEvent e) throws Exception {		
		try {
			importData(this);
		} catch (Exception e2) {
			if(rowCount != 0) {
				int rowCounts = this.editorModel.getBillCardPanel().getRowCount();
				//ѭɾ
				for(int j = rowCounts;j>rowCount;j--){
					System.out.println(j);
					this.editorModel.getBillCardPanel().getBillModel().delLine(new int[] {j-1});
				}	
			}
			if("Cannot get a text value from a numeric cell".equals(e2.getMessage())) {
				throw new Exception("ͽݱΪıʽExcle");
			}else {
				throw e2;
			}			
		}
	}

	/**
	 * Excelݵ
	 *
	 * @author conn
	 * @throws Exception
	 * @return void
	 * @date 2019-9-11
	 * @param importBodyAction
	 */
	public  void importData(ImportBodyAction importBodyAction) throws Exception {
		BillCardPanel cp = importBodyAction.editorModel.getBillCardPanel();
		//ֻӦĿ ӦĿʹ
		String type = sqlexecuteQuery("billtypename", "bd_billtype", "pk_billtypeid", cp.getHeadItem("pk_tradetypeid").getValueObject().toString(),null,0);
		//Ӧ
		String billno = cp.getHeadItem("billno").getValueObject().toString();
		if(!"ӦĿ".equals(type) && !"ӦĿ".equals(type) && !"ԤĿ".equals(type) && !"ԤĿ".equals(type)) {
			return;
		}
		importHendBeforCheck(cp,type);
		String filePath = null;
		FileInputStream fis = null;
		HSSFWorkbook hw = null;

		// ½һļѡ
		JFileChooser jfile = new JFileChooser();
		jfile.setDialogType(JFileChooser.SAVE_DIALOG);
		if (jfile.showSaveDialog(tp) == JFileChooser.CANCEL_OPTION) {
		    return;
		}
		// ȡѡļ
		filePath = jfile.getSelectedFile().toString();
		try {
		    fis = new FileInputStream(filePath);
		} catch (FileNotFoundException e) {
		    ExceptionUtils.wrapException(new Exception(e.getMessage()));
		    e.printStackTrace();
		}
		try {
		    hw = new HSSFWorkbook(fis); // ʹHSSFWorkbook
		} catch (IOException e) {
		    e.printStackTrace();
		    ExceptionUtils.wrapException(new Exception(e.getMessage()));
		} finally {
		    try {
		        fis.close();
		    } catch (IOException e) {
		        e.printStackTrace();
		        ExceptionUtils.wrapException(new Exception(e.getMessage()));
		    }
		}

		// 0ʼ
		HSSFSheet sheet = hw.getSheetAt(0);

		// ȡ
		int rowNum = sheet.getLastRowNum() + 1;

		rowCount = cp.getRowCount();

		//жϱ
		importBodyBeforCheck(sheet,type, rowNum);
		for (int i = 2; i < rowNum; i++) {
			
			int count = cp.getRowCount();
			cp.addLine();
			//Ŀģ
			if("ӦĿ".equals(type)) {
				//Ʊ
				String vbillcode = sheet.getRow(i).getCell(4).getStringCellValue();
				PayableBillItemVO PayableBillItemVO = queryBillItem(billno,vbillcode);
				String pk_org = PayableBillItemVO.getPk_org();
				//ժҪ
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(0).getStringCellValue(),"999"),count, "def25");
				//ù
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(1).getStringCellValue(),"05"),count, "def30");
				//Ԥ
				cp.setBodyValueAt(sheet.getRow(i).getCell(2).getStringCellValue(), count, "def1");
				//Ԥ
				cp.setBodyValueAt(sqlexecuteQuery("pk_inoutbusiclass", "bd_inoutbusiclass", "name", sheet.getRow(i).getCell(3).getStringCellValue(),null,2), count,"pk_subjcode");
				//Ʊ
				cp.setBodyValueAt(vbillcode, count, "def12");
				Object quantity_bal = sheet.getRow(i).getCell(5).getCellType() == 1 ? sheet.getRow(i).getCell(5).getStringCellValue() : sheet.getRow(i).getCell(5).getNumericCellValue();
				//
				cp.setBodyValueAt(quantity_bal,count, "quantity_bal");
				//
				cp.setBodyValueAt(quantity_bal,count, "quantity_cr");
				//㷽ʽ
				cp.setBodyValueAt(sqlexecuteQuery("pk_balatype", "bd_balatype", "name", sheet.getRow(i).getCell(6).getStringCellValue(), null,2),count, "pk_balatype");
				//˰
				cp.setBodyValueAt(sqlexecuteQuery("pk_taxcode", "bd_taxcode", "description", sheet.getRow(i).getCell(7).getStringCellValue(), null,2),count, "taxcodeid");	
				//˰
				cp.setBodyValueAt(sheet.getRow(i).getCell(8).getStringCellValue(),count, "taxrate");
 				Object price = null;
				if(dateUnit(sheet,i,9) != null) {
					price = sheet.getRow(i).getCell(9).getCellType() == 1 ? sheet.getRow(i).getCell(9).getStringCellValue() : sheet.getRow(i).getCell(9).getNumericCellValue();
				}
				//
				cp.setBodyValueAt(price,count, "price");
				//ҵ
				cp.setBodyValueAt(price,count, "local_price");
				Object caltaxmny = sheet.getRow(i).getCell(10).getCellType() == 1 ? sheet.getRow(i).getCell(10).getStringCellValue() : sheet.getRow(i).getCell(10).getNumericCellValue();
				//˰
				cp.setBodyValueAt(caltaxmny,count, "caltaxmny");
				//ԭ˰
				cp.setBodyValueAt(caltaxmny,count, "notax_cr");
				//֯˰
				cp.setBodyValueAt(caltaxmny,count, "local_notax_cr");
				//˰
				cp.setBodyValueAt(sheet.getRow(i).getCell(11).getCellType() == 1 ? sheet.getRow(i).getCell(11).getStringCellValue() : sheet.getRow(i).getCell(11).getNumericCellValue(),count, "local_tax_cr");
				//ԭ
				Object money_bal = sheet.getRow(i).getCell(12).getCellType() == 1 ? sheet.getRow(i).getCell(12).getStringCellValue() : sheet.getRow(i).getCell(12).getNumericCellValue();
				cp.setBodyValueAt(money_bal,count, "money_bal");
				//֯
				cp.setBodyValueAt(money_bal,count, "local_money_bal");
				//ԭҽ
				cp.setBodyValueAt(money_bal,count, "money_cr");
				//֯ҽ
				cp.setBodyValueAt(money_bal,count, "local_money_cr");
				//Ԥռԭ
				cp.setBodyValueAt(money_bal,count, "occupationmny");
				//񺽷չ
				cp.setBodyValueAt(dateUnit(sheet,i,13), count, "def29");
				//
				cp.setBodyValueAt(dateUnit(sheet,i,14),count, "def21");
				//ͻ
				cp.setBodyValueAt(dateUnit(sheet,i,15) == null ? null : sqlexecuteQueryDoc(sheet.getRow(i).getCell(15).getStringCellValue(), "CUST"),count, "def13");
				//ͻ㼶
				cp.setBodyValueAt(dateUnit(sheet,i,16),count, "def22");
				//ԭƱ
				cp.setBodyValueAt(dateUnit(sheet,i,17),count, "def17");
				//ע
				cp.setBodyValueAt(dateUnit(sheet,i,18),count, "def2");
				//Ա
				cp.setBodyValueAt(dateUnit(sheet,i,19),count, "def40");
				//ɱ
				cp.setBodyValueAt(sqlexecuteQuery("pk_dept", "org_dept", "name", sheet.getRow(i).getCell(20).getStringCellValue(), pk_org,2),count, "def23");
				String pk_material = sqlexecuteQuery("pk_material", "bd_material", "name", sheet.getRow(i).getCell(21).getStringCellValue(), null, 2);
				//
				cp.setBodyValueAt(pk_material,count, "material");
				//ԭʼ
				cp.setBodyValueAt(pk_material,count, "material_src");
				//˰
				cp.setBodyValueAt(PayableBillItemVO.getTaxprice(),count, "taxprice");
				//Һ˰
				cp.setBodyValueAt(PayableBillItemVO.getLocal_taxprice(),count, "local_taxprice");
				//ʲͬ
				cp.setBodyValueAt(PayableBillItemVO.getAssetpactno(),count, "assetpactno");
				//  ʽƻĿ
				cp.setBodyValueAt(PayableBillItemVO.getBankrollprojet(),count, "bankrollprojet");
				//  ݴ
				cp.setBodyValueAt(PayableBillItemVO.getBillclass(),count, "billclass");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBilldate(),count, "billdate");
				//  ݺ
				cp.setBodyValueAt(PayableBillItemVO.getBillno(),count, "billno");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBusidate(),count, "busidate");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBuysellflag(),count, "buysellflag");
				//  ֽĿ
				cp.setBodyValueAt(PayableBillItemVO.getCashitem(),count, "cashitem");
				//  CBS
				cp.setBodyValueAt(PayableBillItemVO.getCbs(),count, "cbs");
				//  κҪ
				cp.setBodyValueAt(PayableBillItemVO.getCheckelement(),count, "checkelement");
				//  Ʊ
				cp.setBodyValueAt(PayableBillItemVO.getChecktype(),count, "checktype");
				//  ժҪc
				cp.setBodyValueAt(PayableBillItemVO.getComment(),count, "comment");
				//  ڲ׽
				cp.setBodyValueAt(PayableBillItemVO.getConfernum(),count, "confernum");
				//  ͬ
				cp.setBodyValueAt(PayableBillItemVO.getContractno(),count, "contractno");
				//  Эͬ״̬
				cp.setBodyValueAt(PayableBillItemVO.getCoordflag(),count, "coordflag");
				//  ɱ
				cp.setBodyValueAt(PayableBillItemVO.getCostcenter(),count, "costcenter");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getDirection(),count, "direction");
				//  豸
				cp.setBodyValueAt(PayableBillItemVO.getEquipmentcode(),count, "equipmentcode");
				//  ̶ʲƬ
				cp.setBodyValueAt(PayableBillItemVO.getFacard(),count, "facard");
				//  ɢ
				cp.setBodyValueAt(PayableBillItemVO.getFreecust(),count, "freecust");
				//  ȫֱ
				cp.setBodyValueAt(PayableBillItemVO.getGlobalbalance(),count, "globalbalance");
				//  ȫֱҽ()
				cp.setBodyValueAt(PayableBillItemVO.getGlobalcrebit(),count, "globalcrebit");
				//  ȫֱ˰()
				cp.setBodyValueAt(PayableBillItemVO.getGlobalnotax_cre(),count, "globalnotax_cre");
				//  ȫֱһ
				cp.setBodyValueAt(PayableBillItemVO.getGlobalrate(),count, "globalrate");
				//  ű
				cp.setBodyValueAt(PayableBillItemVO.getGroupbalance(),count, "groupbalance");
				//  űҽ()
				cp.setBodyValueAt(PayableBillItemVO.getGroupcrebit(),count, "groupcrebit");
				//  ű˰()
				cp.setBodyValueAt(PayableBillItemVO.getGroupnotax_cre(),count, "groupnotax_cre");
				//  űһ
				cp.setBodyValueAt(PayableBillItemVO.getGrouprate(),count, "grouprate");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getInnerorderno(),count, "innerorderno");
				//  Ʊ
				cp.setBodyValueAt(PayableBillItemVO.getInvoiceno(),count, "invoiceno");
				//  ɵֿ˰
				cp.setBodyValueAt(PayableBillItemVO.getNosubtax(),count, "nosubtax");
				//  ɵֿ˰
				cp.setBodyValueAt(PayableBillItemVO.getNosubtaxrate(),count, "nosubtaxrate");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getObjtype(),count, "objtype");
				//  Ƿ˰
				cp.setBodyValueAt(PayableBillItemVO.getOpptaxflag(),count, "opptaxflag");
				//  Ӧ
				cp.setBodyValueAt(PayableBillItemVO.getOrdercubasdoc(),count, "ordercubasdoc");
				//  ⵥ
				cp.setBodyValueAt(PayableBillItemVO.getOutstoreno(),count, "outstoreno");
				//  ־
				cp.setBodyValueAt(PayableBillItemVO.getPausetransact(),count, "pausetransact");
				//  ˻
				cp.setBodyValueAt(PayableBillItemVO.getPayaccount(),count, "payaccount");
				//  ͱ
				cp.setBodyValueAt(PayableBillItemVO.getPk_billtype(),count, "pk_billtype");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_currtype(),count, "pk_currtype");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_deptid(),count, "pk_deptid");
				//   
				cp.setBodyValueAt(PayableBillItemVO.getPk_deptid_v(),count, "pk_deptid_v");
				//  ֯
				cp.setBodyValueAt(PayableBillItemVO.getPk_fiorg(),count, "pk_fiorg");
				//  ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_fiorg_v(),count, "pk_fiorg_v");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_group(),count, "pk_group");
				//  Ӧ֯
				cp.setBodyValueAt(PayableBillItemVO.getPk_org(),count, "pk_org");
				//  Ӧ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_org_v(),count, "pk_org_v");
				//  ӦӦʶ
				cp.setBodyValueAt(PayableBillItemVO.getPk_payablebill(),count, "pk_payablebill");
				//  Э
				cp.setBodyValueAt(PayableBillItemVO.getPk_payterm(),count, "pk_payterm");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_pcorg(),count, "pk_pcorgz");
				//  İ汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_pcorg_v(),count, "pk_pcorg_v");
				//  ҵԱ
				cp.setBodyValueAt(PayableBillItemVO.getPk_psndoc(),count, "pk_psndoc");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_ssitem(),count, "pk_ssitem");
				//  Ӧcode
				cp.setBodyValueAt(PayableBillItemVO.getPk_tradetype(),count, "pk_tradetype");
				//  Ӧ
				cp.setBodyValueAt(PayableBillItemVO.getPk_tradetypeid(),count, "pk_tradetypeid");
				//  ۵λ˰
				cp.setBodyValueAt(PayableBillItemVO.getPostprice(),count, "postprice");
				//  ۵λ˰
				cp.setBodyValueAt(PayableBillItemVO.getPostpricenotax(),count, "postpricenotax");
				//  ۵λ
				cp.setBodyValueAt(PayableBillItemVO.getPostquantity(),count, "postquantity");
				//  ۼλ
				cp.setBodyValueAt(PayableBillItemVO.getPostunit(),count, "postunit");
				//  Ʒ
				cp.setBodyValueAt(PayableBillItemVO.getProductline(),count, "productline");
				//  Ŀ
				cp.setBodyValueAt(PayableBillItemVO.getProject(),count, "project");
				//  Ŀ
				cp.setBodyValueAt(PayableBillItemVO.getProject_task(),count, "project_task");
				//  ҵ
				cp.setBodyValueAt(PayableBillItemVO.getPu_deptid(),count, "pu_deptid");
				//  ҵŰ汾
				cp.setBodyValueAt(PayableBillItemVO.getPu_deptid_v(),count, "pu_deptid_v");
				//  ҵ֯
				cp.setBodyValueAt(PayableBillItemVO.getPu_org(),count, "pu_org");
				//  ҵ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPu_org_v(),count, "pu_org_v");
				//  ҵԱ
				cp.setBodyValueAt(PayableBillItemVO.getPu_psndoc(),count, "pu_psndoc");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPurchaseorder(),count, "purchaseorder");
				//  ֯һ
				cp.setBodyValueAt(PayableBillItemVO.getRate(),count, "rate");
				//  տ˻
				cp.setBodyValueAt(PayableBillItemVO.getRecaccount(),count, "recaccount");
				//  ݷ¼
				cp.setBodyValueAt(i-1,count, "rowno");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getRowtype(),count, "rowtype");
				//  ժҪ
				cp.setBodyValueAt(PayableBillItemVO.getScomment(),count, "scomment");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSendcountryid(),count, "sendcountryid");
				//  ֯
				cp.setBodyValueAt(PayableBillItemVO.getSett_org(),count, "sett_org");
				//  ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getSett_org_v(),count, "sett_org_v");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSettlecurr(),count, "settlecurr");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSettlemoney(),count, "settlemoney");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_billid(),count, "src_billid");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_billtype(),count, "src_billtype");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_itemid(),count, "src_itemid");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_tradetype(),count, "src_tradetype");
				//  Ŀ
				cp.setBodyValueAt(PayableBillItemVO.getSubjcode(),count, "subjcode");
				//  Ӧ
				cp.setBodyValueAt(PayableBillItemVO.getSupplier(),count, "supplier");
				//  ˰
				cp.setBodyValueAt(PayableBillItemVO.getTaxnum(),count, "taxnum");
				//  ˰
				cp.setBodyValueAt(PayableBillItemVO.getTaxtype(),count, "taxtype");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_billid(),count, "top_billid");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_billtype(),count, "top_billtype");
				//  ӽʱ
				cp.setBodyValueAt(PayableBillItemVO.getTop_changets(),count, "top_changets");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_itemid(),count, "top_itemid");
				//  ϲ㽻
				cp.setBodyValueAt(PayableBillItemVO.getTop_tradetype(),count, "top_tradetype");
				//  VATע
				cp.setBodyValueAt(PayableBillItemVO.getVatcode(),count, "vatcode");
				//  ӦVATע
				cp.setBodyValueAt(PayableBillItemVO.getVendorvatcode(),count, "vendorvatcode");
				//Զ1-60
				cp.setBodyValueAt(PayableBillItemVO.getDef3(),count,"def3");
				cp.setBodyValueAt(PayableBillItemVO.getDef4(),count,"def4");
				cp.setBodyValueAt(PayableBillItemVO.getDef5(),count,"def5");
				cp.setBodyValueAt(PayableBillItemVO.getDef6(),count,"def6");
				cp.setBodyValueAt(PayableBillItemVO.getDef7(),count,"def7");
				cp.setBodyValueAt(PayableBillItemVO.getDef8(),count,"def8");
				cp.setBodyValueAt(PayableBillItemVO.getDef9(),count,"def9");
				cp.setBodyValueAt(PayableBillItemVO.getDef10(),count,"def10");
				cp.setBodyValueAt(PayableBillItemVO.getDef11(),count,"def11");
				cp.setBodyValueAt(PayableBillItemVO.getDef14(),count,"def14");
				cp.setBodyValueAt(PayableBillItemVO.getDef15(),count,"def15");
				cp.setBodyValueAt(PayableBillItemVO.getDef16(),count,"def16");
				cp.setBodyValueAt(PayableBillItemVO.getDef18(),count,"def18");
				cp.setBodyValueAt(PayableBillItemVO.getDef19(),count,"def19");
				cp.setBodyValueAt(PayableBillItemVO.getDef20(),count,"def20");
				cp.setBodyValueAt(PayableBillItemVO.getDef24(),count,"def24");
				cp.setBodyValueAt(PayableBillItemVO.getDef26(),count,"def26");
				cp.setBodyValueAt(PayableBillItemVO.getDef27(),count,"def27");
				cp.setBodyValueAt(PayableBillItemVO.getDef28(),count,"def28");
				cp.setBodyValueAt(PayableBillItemVO.getDef31(),count,"def31");
				cp.setBodyValueAt(PayableBillItemVO.getDef32(),count,"def32");
				cp.setBodyValueAt(PayableBillItemVO.getDef33(),count,"def33");
				cp.setBodyValueAt(PayableBillItemVO.getDef34(),count,"def34");
				cp.setBodyValueAt(PayableBillItemVO.getDef35(),count,"def35");
				cp.setBodyValueAt(PayableBillItemVO.getDef36(),count,"def36");
				cp.setBodyValueAt(PayableBillItemVO.getDef37(),count,"def37");
				cp.setBodyValueAt(PayableBillItemVO.getDef38(),count,"def38");
				cp.setBodyValueAt(PayableBillItemVO.getDef39(),count,"def39");
				cp.setBodyValueAt(PayableBillItemVO.getDef41(),count,"def41");
				cp.setBodyValueAt(PayableBillItemVO.getDef42(),count,"def42");
				cp.setBodyValueAt(PayableBillItemVO.getDef43(),count,"def43");
				cp.setBodyValueAt(PayableBillItemVO.getDef44(),count,"def44");
				cp.setBodyValueAt(PayableBillItemVO.getDef45(),count,"def45");
				cp.setBodyValueAt(PayableBillItemVO.getDef46(),count,"def46");
				cp.setBodyValueAt(PayableBillItemVO.getDef47(),count,"def47");
				cp.setBodyValueAt(PayableBillItemVO.getDef48(),count,"def48");
				cp.setBodyValueAt(PayableBillItemVO.getDef49(),count,"def49");
				cp.setBodyValueAt(PayableBillItemVO.getDef50(),count,"def50");
				cp.setBodyValueAt(PayableBillItemVO.getDef51(),count,"def51");
				cp.setBodyValueAt(PayableBillItemVO.getDef52(),count,"def52");
				cp.setBodyValueAt(PayableBillItemVO.getDef53(),count,"def53");
				cp.setBodyValueAt(PayableBillItemVO.getDef54(),count,"def54");
				cp.setBodyValueAt(PayableBillItemVO.getDef55(),count,"def55");
				cp.setBodyValueAt(PayableBillItemVO.getDef56(),count,"def56");
				cp.setBodyValueAt(PayableBillItemVO.getDef57(),count,"def57");
				cp.setBodyValueAt(PayableBillItemVO.getDef58(),count,"def58");
				cp.setBodyValueAt(PayableBillItemVO.getDef59(),count,"def59");
				cp.setBodyValueAt(PayableBillItemVO.getDef60(),count,"def60");

			}else if("ӦĿ".equals(type)){
				//Ʊ
				String vbillcode = sheet.getRow(i).getCell(6).getStringCellValue();
				PayableBillItemVO PayableBillItemVO = queryBillItem(billno,vbillcode);
				String pk_org = PayableBillItemVO.getPk_org();
				//ժҪ
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(0).getStringCellValue(),"999"),count, "def25");
				//ù
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(1).getStringCellValue(),"05"),count, "def30");
				//Ŀ
				cp.setBodyValueAt(sheet.getRow(i).getCell(2).getStringCellValue(), count, "def18");
				//Ŀ
				cp.setBodyValueAt(sqlexecuteQuery("pk_project", "bd_project", "project_name", sheet.getRow(i).getCell(3).getStringCellValue(),null,2), count, "project");
				//רҵ
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(4).getStringCellValue(), "HR016"), count, "def6");
				//
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(5).getStringCellValue(), "88"), count, "def7");
				//Ʊ
				cp.setBodyValueAt(sheet.getRow(i).getCell(6).getStringCellValue(), count, "def12");
				Object quantity_bal = sheet.getRow(i).getCell(7).getCellType() == 1 ? sheet.getRow(i).getCell(7).getStringCellValue() : sheet.getRow(i).getCell(7).getNumericCellValue();
				//
				cp.setBodyValueAt(quantity_bal,count, "quantity_bal");
				//
				cp.setBodyValueAt(quantity_bal,count, "quantity_cr");
				//˰
				cp.setBodyValueAt(sqlexecuteQuery("pk_taxcode", "bd_taxcode", "description", sheet.getRow(i).getCell(8).getStringCellValue(), null,2),count, "taxcodeid");	
				//˰
				cp.setBodyValueAt(sheet.getRow(i).getCell(9).getStringCellValue(),count, "taxrate");
				//㷽ʽ
				cp.setBodyValueAt(sqlexecuteQuery("pk_balatype", "bd_balatype", "name", sheet.getRow(i).getCell(10).getStringCellValue(), null,2),count, "pk_balatype");
				Object price = null;
				if(dateUnit(sheet,i,11) != null) {
					price = sheet.getRow(i).getCell(11).getCellType() == 1 ? sheet.getRow(i).getCell(11).getStringCellValue() : sheet.getRow(i).getCell(11).getNumericCellValue();
				}
				//
				cp.setBodyValueAt(price,count, "price");
				//ҵ
				cp.setBodyValueAt(price,count, "local_price");
				Object caltaxmny = sheet.getRow(i).getCell(12).getCellType() == 1 ? sheet.getRow(i).getCell(12).getStringCellValue() : sheet.getRow(i).getCell(12).getNumericCellValue();
				//˰
				cp.setBodyValueAt(caltaxmny,count, "caltaxmny");
				//ԭ˰
				cp.setBodyValueAt(caltaxmny,count, "notax_cr");
				//֯˰
				cp.setBodyValueAt(caltaxmny,count, "local_notax_cr");
				//˰
				cp.setBodyValueAt(sheet.getRow(i).getCell(13).getCellType() == 1 ? sheet.getRow(i).getCell(13).getStringCellValue() : sheet.getRow(i).getCell(13).getNumericCellValue() ,count, "local_tax_cr");
				//񺽷չ
				cp.setBodyValueAt(dateUnit(sheet, i, 14),count, "def29");
				Object money_bal = sheet.getRow(i).getCell(15).getCellType() == 1 ? sheet.getRow(i).getCell(15).getStringCellValue() : sheet.getRow(i).getCell(15).getNumericCellValue();
				//ԭ
				cp.setBodyValueAt(money_bal,count, "money_bal");
				//֯
				cp.setBodyValueAt(money_bal,count, "local_money_bal");
				//ԭҽ
				cp.setBodyValueAt(money_bal,count, "money_cr");
				//֯ҽ
				cp.setBodyValueAt(money_bal,count, "local_money_cr");
				//Ԥռԭ
				cp.setBodyValueAt(money_bal,count, "occupationmny");
				//
				cp.setBodyValueAt(dateUnit(sheet, i, 16),count, "def21");
				//ɱ
				cp.setBodyValueAt(sqlexecuteQuery("pk_dept", "org_dept", "name", sheet.getRow(i).getCell(17).getStringCellValue(), pk_org,2),count, "def22");
				//Ʊݺ/
				cp.setBodyValueAt(dateUnit(sheet, i, 18), count, "def5");
				//ע
				cp.setBodyValueAt(dateUnit(sheet, i, 19), count, "def2");
				//Ԥ
				cp.setBodyValueAt(sqlexecuteQuery("pk_inoutbusiclass", "bd_inoutbusiclass", "name", sheet.getRow(i).getCell(20).getStringCellValue(), null,2),count, "pk_subjcode");
				String pk_material = sqlexecuteQuery("pk_material", "bd_material", "name", sheet.getRow(i).getCell(21).getStringCellValue(), null, 2);
				//
				cp.setBodyValueAt(pk_material,count, "material");
				//ԭʼ
				cp.setBodyValueAt(pk_material,count, "material_src");
				//˰
				cp.setBodyValueAt(PayableBillItemVO.getTaxprice(),count, "taxprice");
				//Һ˰
				cp.setBodyValueAt(PayableBillItemVO.getLocal_taxprice(),count, "local_taxprice");
				//ʲͬ
				cp.setBodyValueAt(PayableBillItemVO.getAssetpactno(),count, "assetpactno");
				//  ʽƻĿ
				cp.setBodyValueAt(PayableBillItemVO.getBankrollprojet(),count, "bankrollprojet");
				//  ݴ
				cp.setBodyValueAt(PayableBillItemVO.getBillclass(),count, "billclass");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBilldate(),count, "billdate");
				//  ݺ
				cp.setBodyValueAt(PayableBillItemVO.getBillno(),count, "billno");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBusidate(),count, "busidate");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBuysellflag(),count, "buysellflag");
				//  ֽĿ
				cp.setBodyValueAt(PayableBillItemVO.getCashitem(),count, "cashitem");
				//  CBS
				cp.setBodyValueAt(PayableBillItemVO.getCbs(),count, "cbs");
				//  κҪ
				cp.setBodyValueAt(PayableBillItemVO.getCheckelement(),count, "checkelement");
				//  Ʊ
				cp.setBodyValueAt(PayableBillItemVO.getChecktype(),count, "checktype");
				//  ժҪc
				cp.setBodyValueAt(PayableBillItemVO.getComment(),count, "comment");
				//  ڲ׽
				cp.setBodyValueAt(PayableBillItemVO.getConfernum(),count, "confernum");
				//  ͬ
				cp.setBodyValueAt(PayableBillItemVO.getContractno(),count, "contractno");
				//  Эͬ״̬
				cp.setBodyValueAt(PayableBillItemVO.getCoordflag(),count, "coordflag");
				//  ɱ
				cp.setBodyValueAt(PayableBillItemVO.getCostcenter(),count, "costcenter");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getDirection(),count, "direction");
				//  豸
				cp.setBodyValueAt(PayableBillItemVO.getEquipmentcode(),count, "equipmentcode");
				//  ̶ʲƬ
				cp.setBodyValueAt(PayableBillItemVO.getFacard(),count, "facard");
				//  ɢ
				cp.setBodyValueAt(PayableBillItemVO.getFreecust(),count, "freecust");
				//  ȫֱ
				cp.setBodyValueAt(PayableBillItemVO.getGlobalbalance(),count, "globalbalance");
				//  ȫֱҽ()
				cp.setBodyValueAt(PayableBillItemVO.getGlobalcrebit(),count, "globalcrebit");
				//  ȫֱ˰()
				cp.setBodyValueAt(PayableBillItemVO.getGlobalnotax_cre(),count, "globalnotax_cre");
				//  ȫֱһ
				cp.setBodyValueAt(PayableBillItemVO.getGlobalrate(),count, "globalrate");
				//  ű
				cp.setBodyValueAt(PayableBillItemVO.getGroupbalance(),count, "groupbalance");
				//  űҽ()
				cp.setBodyValueAt(PayableBillItemVO.getGroupcrebit(),count, "groupcrebit");
				//  ű˰()
				cp.setBodyValueAt(PayableBillItemVO.getGroupnotax_cre(),count, "groupnotax_cre");
				//  űһ
				cp.setBodyValueAt(PayableBillItemVO.getGrouprate(),count, "grouprate");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getInnerorderno(),count, "innerorderno");
				//  Ʊ
				cp.setBodyValueAt(PayableBillItemVO.getInvoiceno(),count, "invoiceno");
				//  ɵֿ˰
				cp.setBodyValueAt(PayableBillItemVO.getNosubtax(),count, "nosubtax");
				//  ɵֿ˰
				cp.setBodyValueAt(PayableBillItemVO.getNosubtaxrate(),count, "nosubtaxrate");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getObjtype(),count, "objtype");
				//  Ƿ˰
				cp.setBodyValueAt(PayableBillItemVO.getOpptaxflag(),count, "opptaxflag");
				//  Ӧ
				cp.setBodyValueAt(PayableBillItemVO.getOrdercubasdoc(),count, "ordercubasdoc");
				//  ⵥ
				cp.setBodyValueAt(PayableBillItemVO.getOutstoreno(),count, "outstoreno");
				//  ־
				cp.setBodyValueAt(PayableBillItemVO.getPausetransact(),count, "pausetransact");
				//  ˻
				cp.setBodyValueAt(PayableBillItemVO.getPayaccount(),count, "payaccount");
				//  ͱ
				cp.setBodyValueAt(PayableBillItemVO.getPk_billtype(),count, "pk_billtype");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_currtype(),count, "pk_currtype");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_deptid(),count, "pk_deptid");
				//   
				cp.setBodyValueAt(PayableBillItemVO.getPk_deptid_v(),count, "pk_deptid_v");
				//  ֯
				cp.setBodyValueAt(PayableBillItemVO.getPk_fiorg(),count, "pk_fiorg");
				//  ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_fiorg_v(),count, "pk_fiorg_v");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_group(),count, "pk_group");
				//  Ӧ֯
				cp.setBodyValueAt(PayableBillItemVO.getPk_org(),count, "pk_org");
				//  Ӧ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_org_v(),count, "pk_org_v");
				//  ӦӦʶ
				cp.setBodyValueAt(PayableBillItemVO.getPk_payablebill(),count, "pk_payablebill");
				//  Э
				cp.setBodyValueAt(PayableBillItemVO.getPk_payterm(),count, "pk_payterm");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_pcorg(),count, "pk_pcorgz");
				//  İ汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_pcorg_v(),count, "pk_pcorg_v");
				//  ҵԱ
				cp.setBodyValueAt(PayableBillItemVO.getPk_psndoc(),count, "pk_psndoc");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_ssitem(),count, "pk_ssitem");
				//  Ӧcode
				cp.setBodyValueAt(PayableBillItemVO.getPk_tradetype(),count, "pk_tradetype");
				//  Ӧ
				cp.setBodyValueAt(PayableBillItemVO.getPk_tradetypeid(),count, "pk_tradetypeid");
				//  ۵λ˰
				cp.setBodyValueAt(PayableBillItemVO.getPostprice(),count, "postprice");
				//  ۵λ˰
				cp.setBodyValueAt(PayableBillItemVO.getPostpricenotax(),count, "postpricenotax");
				//  ۵λ
				cp.setBodyValueAt(PayableBillItemVO.getPostquantity(),count, "postquantity");
				//  ۼλ
				cp.setBodyValueAt(PayableBillItemVO.getPostunit(),count, "postunit");
				//  Ʒ
				cp.setBodyValueAt(PayableBillItemVO.getProductline(),count, "productline");
				//  Ŀ
				cp.setBodyValueAt(PayableBillItemVO.getProject_task(),count, "project_task");
				//  ҵ
				cp.setBodyValueAt(PayableBillItemVO.getPu_deptid(),count, "pu_deptid");
				//  ҵŰ汾
				cp.setBodyValueAt(PayableBillItemVO.getPu_deptid_v(),count, "pu_deptid_v");
				//  ҵ֯
				cp.setBodyValueAt(PayableBillItemVO.getPu_org(),count, "pu_org");
				//  ҵ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPu_org_v(),count, "pu_org_v");
				//  ҵԱ
				cp.setBodyValueAt(PayableBillItemVO.getPu_psndoc(),count, "pu_psndoc");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPurchaseorder(),count, "purchaseorder");
				//  ֯һ
				cp.setBodyValueAt(PayableBillItemVO.getRate(),count, "rate");
				//  տ˻
				cp.setBodyValueAt(PayableBillItemVO.getRecaccount(),count, "recaccount");
				//  ݷ¼
				cp.setBodyValueAt(i-1,count, "rowno");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getRowtype(),count, "rowtype");
				//  ժҪ
				cp.setBodyValueAt(PayableBillItemVO.getScomment(),count, "scomment");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSendcountryid(),count, "sendcountryid");
				//  ֯
				cp.setBodyValueAt(PayableBillItemVO.getSett_org(),count, "sett_org");
				//  ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getSett_org_v(),count, "sett_org_v");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSettlecurr(),count, "settlecurr");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSettlemoney(),count, "settlemoney");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_billid(),count, "src_billid");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_billtype(),count, "src_billtype");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_itemid(),count, "src_itemid");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_tradetype(),count, "src_tradetype");
				//  Ŀ
				cp.setBodyValueAt(PayableBillItemVO.getSubjcode(),count, "subjcode");
				//  Ӧ
				cp.setBodyValueAt(PayableBillItemVO.getSupplier(),count, "supplier");
				//  ˰
				cp.setBodyValueAt(PayableBillItemVO.getTaxnum(),count, "taxnum");
				//  ˰
				cp.setBodyValueAt(PayableBillItemVO.getTaxtype(),count, "taxtype");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_billid(),count, "top_billid");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_billtype(),count, "top_billtype");
				//  ӽʱ
				cp.setBodyValueAt(PayableBillItemVO.getTop_changets(),count, "top_changets");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_itemid(),count, "top_itemid");
				//  ϲ㽻
				cp.setBodyValueAt(PayableBillItemVO.getTop_tradetype(),count, "top_tradetype");
				//  VATע
				cp.setBodyValueAt(PayableBillItemVO.getVatcode(),count, "vatcode");
				//  ӦVATע
				cp.setBodyValueAt(PayableBillItemVO.getVendorvatcode(),count, "vendorvatcode");
				//Զ1-60
				cp.setBodyValueAt(PayableBillItemVO.getDef1(),count,"def1");
				cp.setBodyValueAt(PayableBillItemVO.getDef3(),count,"def3");
				cp.setBodyValueAt(PayableBillItemVO.getDef4(),count,"def4");
				cp.setBodyValueAt(PayableBillItemVO.getDef8(),count,"def8");
				cp.setBodyValueAt(PayableBillItemVO.getDef9(),count,"def9");
				cp.setBodyValueAt(PayableBillItemVO.getDef10(),count,"def10");
				cp.setBodyValueAt(PayableBillItemVO.getDef11(),count,"def11");
				cp.setBodyValueAt(PayableBillItemVO.getDef13(),count,"def13");
				cp.setBodyValueAt(PayableBillItemVO.getDef14(),count,"def14");
				cp.setBodyValueAt(PayableBillItemVO.getDef15(),count,"def15");
				cp.setBodyValueAt(PayableBillItemVO.getDef16(),count,"def16");
				cp.setBodyValueAt(PayableBillItemVO.getDef17(),count,"def17");
				cp.setBodyValueAt(PayableBillItemVO.getDef19(),count,"def19");
				cp.setBodyValueAt(PayableBillItemVO.getDef20(),count,"def20");
				cp.setBodyValueAt(PayableBillItemVO.getDef22(),count,"def23");
				cp.setBodyValueAt(PayableBillItemVO.getDef24(),count,"def24");
				cp.setBodyValueAt(PayableBillItemVO.getDef26(),count,"def26");
				cp.setBodyValueAt(PayableBillItemVO.getDef27(),count,"def27");
				cp.setBodyValueAt(PayableBillItemVO.getDef28(),count,"def28");
				cp.setBodyValueAt(PayableBillItemVO.getDef31(),count,"def31");
				cp.setBodyValueAt(PayableBillItemVO.getDef32(),count,"def32");
				cp.setBodyValueAt(PayableBillItemVO.getDef33(),count,"def33");
				cp.setBodyValueAt(PayableBillItemVO.getDef34(),count,"def34");
				cp.setBodyValueAt(PayableBillItemVO.getDef35(),count,"def35");
				cp.setBodyValueAt(PayableBillItemVO.getDef36(),count,"def36");
				cp.setBodyValueAt(PayableBillItemVO.getDef37(),count,"def37");
				cp.setBodyValueAt(PayableBillItemVO.getDef38(),count,"def38");
				cp.setBodyValueAt(PayableBillItemVO.getDef39(),count,"def39");
				cp.setBodyValueAt(PayableBillItemVO.getDef40(),count,"def40");
				cp.setBodyValueAt(PayableBillItemVO.getDef41(),count,"def41");
				cp.setBodyValueAt(PayableBillItemVO.getDef42(),count,"def42");
				cp.setBodyValueAt(PayableBillItemVO.getDef43(),count,"def43");
				cp.setBodyValueAt(PayableBillItemVO.getDef44(),count,"def44");
				cp.setBodyValueAt(PayableBillItemVO.getDef45(),count,"def45");
				cp.setBodyValueAt(PayableBillItemVO.getDef46(),count,"def46");
				cp.setBodyValueAt(PayableBillItemVO.getDef47(),count,"def47");
				cp.setBodyValueAt(PayableBillItemVO.getDef48(),count,"def48");
				cp.setBodyValueAt(PayableBillItemVO.getDef49(),count,"def49");
				cp.setBodyValueAt(PayableBillItemVO.getDef50(),count,"def50");
				cp.setBodyValueAt(PayableBillItemVO.getDef51(),count,"def51");
				cp.setBodyValueAt(PayableBillItemVO.getDef52(),count,"def52");
				cp.setBodyValueAt(PayableBillItemVO.getDef53(),count,"def53");
				cp.setBodyValueAt(PayableBillItemVO.getDef54(),count,"def54");
				cp.setBodyValueAt(PayableBillItemVO.getDef55(),count,"def55");
				cp.setBodyValueAt(PayableBillItemVO.getDef56(),count,"def56");
				cp.setBodyValueAt(PayableBillItemVO.getDef57(),count,"def57");
				cp.setBodyValueAt(PayableBillItemVO.getDef58(),count,"def58");
				cp.setBodyValueAt(PayableBillItemVO.getDef59(),count,"def59");
				cp.setBodyValueAt(PayableBillItemVO.getDef60(),count,"def60");
			}else if("ԤĿ".equals(type)){
				//Ʊ
				String vbillcode = sheet.getRow(i).getCell(4).getStringCellValue();
				PayableBillItemVO PayableBillItemVO = queryBillItem(billno,vbillcode);
				String pk_org = PayableBillItemVO.getPk_org();
				//ժҪ
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(0).getStringCellValue(),"999"),count, "def25");
				//ù
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(1).getStringCellValue(),"05"),count, "def30");
				//Ԥ
				cp.setBodyValueAt(sheet.getRow(i).getCell(2).getStringCellValue(), count, "def1");
				//Ԥ
				cp.setBodyValueAt(sqlexecuteQuery("pk_inoutbusiclass", "bd_inoutbusiclass", "name", sheet.getRow(i).getCell(3).getStringCellValue(),null,2), count,"pk_subjcode");
				//Ʊ
				cp.setBodyValueAt(vbillcode, count, "def12");
				String pk_material = sqlexecuteQuery("pk_material", "bd_material", "name", sheet.getRow(i).getCell(5).getStringCellValue(), null, 2);
				//
				cp.setBodyValueAt(pk_material,count, "material");
				//ԭʼ
				cp.setBodyValueAt(pk_material,count, "material_src");
				//˰
				cp.setBodyValueAt(sqlexecuteQuery("pk_taxcode", "bd_taxcode", "description", sheet.getRow(i).getCell(6).getStringCellValue(), null,2),count, "taxcodeid");	
				//˰
				cp.setBodyValueAt(sheet.getRow(i).getCell(7).getStringCellValue(),count, "taxrate");
 				Object price = null;
				if(dateUnit(sheet,i,8) != null) {
					price = sheet.getRow(i).getCell(8).getCellType() == 1 ? sheet.getRow(i).getCell(8).getStringCellValue() : sheet.getRow(i).getCell(8).getNumericCellValue();
				}
				//
				cp.setBodyValueAt(price,count, "price");
				//ҵ
				cp.setBodyValueAt(price,count, "local_price");
				Object caltaxmny = sheet.getRow(i).getCell(9).getCellType() == 1 ? sheet.getRow(i).getCell(9).getStringCellValue() : sheet.getRow(i).getCell(9).getNumericCellValue();
				//˰
				cp.setBodyValueAt(caltaxmny,count, "caltaxmny");
				//ԭ˰
				cp.setBodyValueAt(caltaxmny,count, "notax_cr");
				//֯˰
				cp.setBodyValueAt(caltaxmny,count, "local_notax_cr");
				//˰
				cp.setBodyValueAt(sheet.getRow(i).getCell(10).getCellType() == 1 ? sheet.getRow(i).getCell(10).getStringCellValue() : sheet.getRow(i).getCell(10).getNumericCellValue(),count, "local_tax_cr");
				//ԭ
				Object money_bal = sheet.getRow(i).getCell(11).getCellType() == 1 ? sheet.getRow(i).getCell(11).getStringCellValue() : sheet.getRow(i).getCell(11).getNumericCellValue();
				cp.setBodyValueAt(money_bal,count, "money_bal");
				//֯
				cp.setBodyValueAt(money_bal,count, "local_money_bal");
				//ԭҽ
				cp.setBodyValueAt(money_bal,count, "money_cr");
				//֯ҽ
				cp.setBodyValueAt(money_bal,count, "local_money_cr");
				//Ԥռԭ
				cp.setBodyValueAt(money_bal,count, "occupationmny");
				//˰
				cp.setBodyValueAt("Ӧ˰ں".equals(sheet.getRow(i).getCell(12).getStringCellValue()) ? 0 : 1,count, "taxtype");
				//ɱ
				cp.setBodyValueAt(sqlexecuteQuery("pk_dept", "org_dept", "name", sheet.getRow(i).getCell(13).getStringCellValue(), pk_org,2),count, "def23");
				//
				Object objtype = dateUnit(sheet,i,14);
				cp.setBodyValueAt("Ӧ".equals(objtype) ? 1 : "".equals(objtype) ? 2 : 3,count, "objtype");
				//ע
				cp.setBodyValueAt(dateUnit(sheet,i,15),count, "def2");
				//Էλ
				cp.setBodyValueAt(sqlexecuteQuery("pk_supplier", "bd_supplier", "name", sheet.getRow(i).getCell(16).getStringCellValue(), null, 2),count,"supplier");
				//
				cp.setBodyValueAt(sqlexecuteQuery("pk_dept", "org_dept", "name", sheet.getRow(i).getCell(17).getStringCellValue(), pk_org, 2),count, "pk_deptid");
				// 
				cp.setBodyValueAt(sqlexecuteQuery("pk_vid", "org_dept_v", "name", sheet.getRow(i).getCell(17).getStringCellValue(), pk_org, 2),count, "pk_deptid_v");
				//˰
				cp.setBodyValueAt(PayableBillItemVO.getTaxprice(),count, "taxprice");
				//Һ˰
				cp.setBodyValueAt(PayableBillItemVO.getLocal_taxprice(),count, "local_taxprice");
				//
				cp.setBodyValueAt(PayableBillItemVO.getQuantity_bal(),count, "quantity_bal");
				//
				cp.setBodyValueAt(PayableBillItemVO.getQuantity_cr(),count, "quantity_cr");
				//㷽ʽ
				cp.setBodyValueAt(PayableBillItemVO.getPk_balatype(),count, "pk_balatype");
				//ʲͬ
				cp.setBodyValueAt(PayableBillItemVO.getAssetpactno(),count, "assetpactno");
				//  ʽƻĿ
				cp.setBodyValueAt(PayableBillItemVO.getBankrollprojet(),count, "bankrollprojet");
				//  ݴ
				cp.setBodyValueAt(PayableBillItemVO.getBillclass(),count, "billclass");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBilldate(),count, "billdate");
				//  ݺ
				cp.setBodyValueAt(PayableBillItemVO.getBillno(),count, "billno");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBusidate(),count, "busidate");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBuysellflag(),count, "buysellflag");
				//  ֽĿ
				cp.setBodyValueAt(PayableBillItemVO.getCashitem(),count, "cashitem");
				//  CBS
				cp.setBodyValueAt(PayableBillItemVO.getCbs(),count, "cbs");
				//  κҪ
				cp.setBodyValueAt(PayableBillItemVO.getCheckelement(),count, "checkelement");
				//  Ʊ
				cp.setBodyValueAt(PayableBillItemVO.getChecktype(),count, "checktype");
				//  ժҪc
				cp.setBodyValueAt(PayableBillItemVO.getComment(),count, "comment");
				//  ڲ׽
				cp.setBodyValueAt(PayableBillItemVO.getConfernum(),count, "confernum");
				//  ͬ
				cp.setBodyValueAt(PayableBillItemVO.getContractno(),count, "contractno");
				//  Эͬ״̬
				cp.setBodyValueAt(PayableBillItemVO.getCoordflag(),count, "coordflag");
				//  ɱ
				cp.setBodyValueAt(PayableBillItemVO.getCostcenter(),count, "costcenter");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getDirection(),count, "direction");
				//  豸
				cp.setBodyValueAt(PayableBillItemVO.getEquipmentcode(),count, "equipmentcode");
				//  ̶ʲƬ
				cp.setBodyValueAt(PayableBillItemVO.getFacard(),count, "facard");
				//  ɢ
				cp.setBodyValueAt(PayableBillItemVO.getFreecust(),count, "freecust");
				//  ȫֱ
				cp.setBodyValueAt(PayableBillItemVO.getGlobalbalance(),count, "globalbalance");
				//  ȫֱҽ()
				cp.setBodyValueAt(PayableBillItemVO.getGlobalcrebit(),count, "globalcrebit");
				//  ȫֱ˰()
				cp.setBodyValueAt(PayableBillItemVO.getGlobalnotax_cre(),count, "globalnotax_cre");
				//  ȫֱһ
				cp.setBodyValueAt(PayableBillItemVO.getGlobalrate(),count, "globalrate");
				//  ű
				cp.setBodyValueAt(PayableBillItemVO.getGroupbalance(),count, "groupbalance");
				//  űҽ()
				cp.setBodyValueAt(PayableBillItemVO.getGroupcrebit(),count, "groupcrebit");
				//  ű˰()
				cp.setBodyValueAt(PayableBillItemVO.getGroupnotax_cre(),count, "groupnotax_cre");
				//  űһ
				cp.setBodyValueAt(PayableBillItemVO.getGrouprate(),count, "grouprate");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getInnerorderno(),count, "innerorderno");
				//  Ʊ
				cp.setBodyValueAt(PayableBillItemVO.getInvoiceno(),count, "invoiceno");
				//  ɵֿ˰
				cp.setBodyValueAt(PayableBillItemVO.getNosubtax(),count, "nosubtax");
				//  ɵֿ˰
				cp.setBodyValueAt(PayableBillItemVO.getNosubtaxrate(),count, "nosubtaxrate");
				//  Ƿ˰
				cp.setBodyValueAt(PayableBillItemVO.getOpptaxflag(),count, "opptaxflag");
				//  Ӧ
				cp.setBodyValueAt(PayableBillItemVO.getOrdercubasdoc(),count, "ordercubasdoc");
				//  ⵥ
				cp.setBodyValueAt(PayableBillItemVO.getOutstoreno(),count, "outstoreno");
				//  ־
				cp.setBodyValueAt(PayableBillItemVO.getPausetransact(),count, "pausetransact");
				//  ˻
				cp.setBodyValueAt(PayableBillItemVO.getPayaccount(),count, "payaccount");
				//  ͱ
				cp.setBodyValueAt(PayableBillItemVO.getPk_billtype(),count, "pk_billtype");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_currtype(),count, "pk_currtype");
				//  ֯
				cp.setBodyValueAt(PayableBillItemVO.getPk_fiorg(),count, "pk_fiorg");
				//  ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_fiorg_v(),count, "pk_fiorg_v");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_group(),count, "pk_group");
				//  Ӧ֯
				cp.setBodyValueAt(PayableBillItemVO.getPk_org(),count, "pk_org");
				//  Ӧ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_org_v(),count, "pk_org_v");
				//  ӦӦʶ
				cp.setBodyValueAt(PayableBillItemVO.getPk_payablebill(),count, "pk_payablebill");
				//  Э
				cp.setBodyValueAt(PayableBillItemVO.getPk_payterm(),count, "pk_payterm");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_pcorg(),count, "pk_pcorgz");
				//  İ汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_pcorg_v(),count, "pk_pcorg_v");
				//  ҵԱ
				cp.setBodyValueAt(PayableBillItemVO.getPk_psndoc(),count, "pk_psndoc");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_ssitem(),count, "pk_ssitem");
				//  Ӧcode
				cp.setBodyValueAt(PayableBillItemVO.getPk_tradetype(),count, "pk_tradetype");
				//  Ӧ
				cp.setBodyValueAt(PayableBillItemVO.getPk_tradetypeid(),count, "pk_tradetypeid");
				//  ۵λ˰
				cp.setBodyValueAt(PayableBillItemVO.getPostprice(),count, "postprice");
				//  ۵λ˰
				cp.setBodyValueAt(PayableBillItemVO.getPostpricenotax(),count, "postpricenotax");
				//  ۵λ
				cp.setBodyValueAt(PayableBillItemVO.getPostquantity(),count, "postquantity");
				//  ۼλ
				cp.setBodyValueAt(PayableBillItemVO.getPostunit(),count, "postunit");
				//  Ʒ
				cp.setBodyValueAt(PayableBillItemVO.getProductline(),count, "productline");
				//  Ŀ
				cp.setBodyValueAt(PayableBillItemVO.getProject(),count, "project");
				//  Ŀ
				cp.setBodyValueAt(PayableBillItemVO.getProject_task(),count, "project_task");
				//  ҵ
				cp.setBodyValueAt(PayableBillItemVO.getPu_deptid(),count, "pu_deptid");
				//  ҵŰ汾
				cp.setBodyValueAt(PayableBillItemVO.getPu_deptid_v(),count, "pu_deptid_v");
				//  ҵ֯
				cp.setBodyValueAt(PayableBillItemVO.getPu_org(),count, "pu_org");
				//  ҵ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPu_org_v(),count, "pu_org_v");
				//  ҵԱ
				cp.setBodyValueAt(PayableBillItemVO.getPu_psndoc(),count, "pu_psndoc");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPurchaseorder(),count, "purchaseorder");
				//  ֯һ
				cp.setBodyValueAt(PayableBillItemVO.getRate(),count, "rate");
				//  տ˻
				cp.setBodyValueAt(PayableBillItemVO.getRecaccount(),count, "recaccount");
				//  ݷ¼
				cp.setBodyValueAt(i-1,count, "rowno");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getRowtype(),count, "rowtype");
				//  ժҪ
				cp.setBodyValueAt(PayableBillItemVO.getScomment(),count, "scomment");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSendcountryid(),count, "sendcountryid");
				//  ֯
				cp.setBodyValueAt(PayableBillItemVO.getSett_org(),count, "sett_org");
				//  ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getSett_org_v(),count, "sett_org_v");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSettlecurr(),count, "settlecurr");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSettlemoney(),count, "settlemoney");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_billid(),count, "src_billid");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_billtype(),count, "src_billtype");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_itemid(),count, "src_itemid");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_tradetype(),count, "src_tradetype");
				//  Ŀ
				cp.setBodyValueAt(PayableBillItemVO.getSubjcode(),count, "subjcode");
				//  ˰
				cp.setBodyValueAt(PayableBillItemVO.getTaxnum(),count, "taxnum");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_billid(),count, "top_billid");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_billtype(),count, "top_billtype");
				//  ӽʱ
				cp.setBodyValueAt(PayableBillItemVO.getTop_changets(),count, "top_changets");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_itemid(),count, "top_itemid");
				//  ϲ㽻
				cp.setBodyValueAt(PayableBillItemVO.getTop_tradetype(),count, "top_tradetype");
				//  VATע
				cp.setBodyValueAt(PayableBillItemVO.getVatcode(),count, "vatcode");
				//  ӦVATע
				cp.setBodyValueAt(PayableBillItemVO.getVendorvatcode(),count, "vendorvatcode");
				//Զ1-60
				cp.setBodyValueAt(PayableBillItemVO.getDef3(),count,"def3");
				cp.setBodyValueAt(PayableBillItemVO.getDef4(),count,"def4");
				cp.setBodyValueAt(PayableBillItemVO.getDef5(),count,"def5");
				cp.setBodyValueAt(PayableBillItemVO.getDef6(),count,"def6");
				cp.setBodyValueAt(PayableBillItemVO.getDef7(),count,"def7");
				cp.setBodyValueAt(PayableBillItemVO.getDef8(),count,"def8");
				cp.setBodyValueAt(PayableBillItemVO.getDef9(),count,"def9");
				cp.setBodyValueAt(PayableBillItemVO.getDef10(),count,"def10");
				cp.setBodyValueAt(PayableBillItemVO.getDef11(),count,"def11");
				cp.setBodyValueAt(PayableBillItemVO.getDef13(),count,"def13");
				cp.setBodyValueAt(PayableBillItemVO.getDef14(),count,"def14");
				cp.setBodyValueAt(PayableBillItemVO.getDef15(),count,"def15");
				cp.setBodyValueAt(PayableBillItemVO.getDef16(),count,"def16");
				cp.setBodyValueAt(PayableBillItemVO.getDef17(),count,"def17");
				cp.setBodyValueAt(PayableBillItemVO.getDef18(),count,"def18");
				cp.setBodyValueAt(PayableBillItemVO.getDef19(),count,"def19");
				cp.setBodyValueAt(PayableBillItemVO.getDef20(),count,"def20");
				cp.setBodyValueAt(PayableBillItemVO.getDef21(),count,"def21");
				cp.setBodyValueAt(PayableBillItemVO.getDef22(),count,"def22");
				cp.setBodyValueAt(PayableBillItemVO.getDef24(),count,"def24");
				cp.setBodyValueAt(PayableBillItemVO.getDef26(),count,"def26");
				cp.setBodyValueAt(PayableBillItemVO.getDef27(),count,"def27");
				cp.setBodyValueAt(PayableBillItemVO.getDef28(),count,"def28");
				cp.setBodyValueAt(PayableBillItemVO.getDef29(), count,"def29");
				cp.setBodyValueAt(PayableBillItemVO.getDef31(),count,"def31");
				cp.setBodyValueAt(PayableBillItemVO.getDef32(),count,"def32");
				cp.setBodyValueAt(PayableBillItemVO.getDef33(),count,"def33");
				cp.setBodyValueAt(PayableBillItemVO.getDef34(),count,"def34");
				cp.setBodyValueAt(PayableBillItemVO.getDef35(),count,"def35");
				cp.setBodyValueAt(PayableBillItemVO.getDef36(),count,"def36");
				cp.setBodyValueAt(PayableBillItemVO.getDef37(),count,"def37");
				cp.setBodyValueAt(PayableBillItemVO.getDef38(),count,"def38");
				cp.setBodyValueAt(PayableBillItemVO.getDef39(),count,"def39");
				cp.setBodyValueAt(PayableBillItemVO.getDef40(),count,"def40");
				cp.setBodyValueAt(PayableBillItemVO.getDef41(),count,"def41");
				cp.setBodyValueAt(PayableBillItemVO.getDef42(),count,"def42");
				cp.setBodyValueAt(PayableBillItemVO.getDef43(),count,"def43");
				cp.setBodyValueAt(PayableBillItemVO.getDef44(),count,"def44");
				cp.setBodyValueAt(PayableBillItemVO.getDef45(),count,"def45");
				cp.setBodyValueAt(PayableBillItemVO.getDef46(),count,"def46");
				cp.setBodyValueAt(PayableBillItemVO.getDef47(),count,"def47");
				cp.setBodyValueAt(PayableBillItemVO.getDef48(),count,"def48");
				cp.setBodyValueAt(PayableBillItemVO.getDef49(),count,"def49");
				cp.setBodyValueAt(PayableBillItemVO.getDef50(),count,"def50");
				cp.setBodyValueAt(PayableBillItemVO.getDef51(),count,"def51");
				cp.setBodyValueAt(PayableBillItemVO.getDef52(),count,"def52");
				cp.setBodyValueAt(PayableBillItemVO.getDef53(),count,"def53");
				cp.setBodyValueAt(PayableBillItemVO.getDef54(),count,"def54");
				cp.setBodyValueAt(PayableBillItemVO.getDef55(),count,"def55");
				cp.setBodyValueAt(PayableBillItemVO.getDef56(),count,"def56");
				cp.setBodyValueAt(PayableBillItemVO.getDef57(),count,"def57");
				cp.setBodyValueAt(PayableBillItemVO.getDef58(),count,"def58");
				cp.setBodyValueAt(PayableBillItemVO.getDef59(),count,"def59");
				cp.setBodyValueAt(PayableBillItemVO.getDef60(),count,"def60");
			}else {
				//Ʊ
				String vbillcode = sheet.getRow(i).getCell(6).getStringCellValue();
				PayableBillItemVO PayableBillItemVO = queryBillItem(billno,vbillcode);
				String pk_org = PayableBillItemVO.getPk_org();
				//ժҪ
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(0).getStringCellValue(),"999"),count, "def25");
				//ù
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(1).getStringCellValue(),"05"),count, "def30");
				//Ŀ
				cp.setBodyValueAt(sheet.getRow(i).getCell(2).getStringCellValue(), count, "def18");
				//Ŀ
				cp.setBodyValueAt(sqlexecuteQuery("pk_project", "bd_project", "project_name", sheet.getRow(i).getCell(3).getStringCellValue(),null,2), count, "project");
				//רҵ
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(4).getStringCellValue(), "HR016"), count, "def6");
				//
				cp.setBodyValueAt(sqlexecuteQueryDoc(sheet.getRow(i).getCell(5).getStringCellValue(), "88"), count, "def7");
				//Ʊ
				cp.setBodyValueAt(vbillcode, count, "def12");
				String pk_material = sqlexecuteQuery("pk_material", "bd_material", "name", sheet.getRow(i).getCell(7).getStringCellValue(), null, 2);
				//
				cp.setBodyValueAt(pk_material,count, "material");
				//ԭʼ
				cp.setBodyValueAt(pk_material,count, "material_src");
				//˰
				cp.setBodyValueAt(sqlexecuteQuery("pk_taxcode", "bd_taxcode", "description", sheet.getRow(i).getCell(8).getStringCellValue(), null,2),count, "taxcodeid");	
				//˰
				cp.setBodyValueAt(sheet.getRow(i).getCell(9).getStringCellValue(),count, "taxrate");
				Object price = null;
				if(dateUnit(sheet,i,10) != null) {
					price = sheet.getRow(i).getCell(10).getCellType() == 1 ? sheet.getRow(i).getCell(10).getStringCellValue() : sheet.getRow(i).getCell(10).getNumericCellValue();
				}
				//
				cp.setBodyValueAt(price,count, "price");
				//ҵ
				cp.setBodyValueAt(price,count, "local_price");
				Object caltaxmny = sheet.getRow(i).getCell(11).getCellType() == 1 ? sheet.getRow(i).getCell(11).getStringCellValue() : sheet.getRow(i).getCell(11).getNumericCellValue();
				//˰
				cp.setBodyValueAt(caltaxmny,count, "caltaxmny");
				//ԭ˰
				cp.setBodyValueAt(caltaxmny,count, "notax_cr");
				//֯˰
				cp.setBodyValueAt(caltaxmny,count, "local_notax_cr");
				//˰
				cp.setBodyValueAt(sheet.getRow(i).getCell(12).getCellType() == 1 ? sheet.getRow(i).getCell(12).getStringCellValue() : sheet.getRow(i).getCell(12).getNumericCellValue() ,count, "local_tax_cr");
				Object money_bal = sheet.getRow(i).getCell(13).getCellType() == 1 ? sheet.getRow(i).getCell(13).getStringCellValue() : sheet.getRow(i).getCell(13).getNumericCellValue();
				//ԭ
				cp.setBodyValueAt(money_bal,count, "money_bal");
				//֯
				cp.setBodyValueAt(money_bal,count, "local_money_bal");
				//ԭҽ
				cp.setBodyValueAt(money_bal,count, "money_cr");
				//֯ҽ
				cp.setBodyValueAt(money_bal,count, "local_money_cr");
				//Ԥռԭ
				cp.setBodyValueAt(money_bal,count, "occupationmny");
				//ɱ
				cp.setBodyValueAt(sqlexecuteQuery("pk_dept", "org_dept", "name", sheet.getRow(i).getCell(14).getStringCellValue(), pk_org,2),count, "def22");
				//˰
				cp.setBodyValueAt("Ӧ˰ں".equals(sheet.getRow(i).getCell(15).getStringCellValue()) ? 0 : 1,count, "taxtype");
				//
				Object objtype = dateUnit(sheet,i,16);
				cp.setBodyValueAt("Ӧ".equals(objtype) ? 1 : "".equals(objtype) ? 2 : 3,count, "objtype");
				//Էλ
				cp.setBodyValueAt(sqlexecuteQuery("pk_supplier", "bd_supplier", "name", sheet.getRow(i).getCell(17).getStringCellValue(), null, 2),count,"supplier");
				//ע
				cp.setBodyValueAt(dateUnit(sheet, i, 18), count, "def2");
				//Ԥ
				cp.setBodyValueAt(sqlexecuteQuery("pk_inoutbusiclass", "bd_inoutbusiclass", "name", sheet.getRow(i).getCell(19).getStringCellValue(), null,2),count, "pk_subjcode");
				//˰
				cp.setBodyValueAt(PayableBillItemVO.getTaxprice(),count, "taxprice");
				//Һ˰
				cp.setBodyValueAt(PayableBillItemVO.getLocal_taxprice(),count, "local_taxprice");
				//
				cp.setBodyValueAt(PayableBillItemVO.getQuantity_bal(),count, "quantity_bal");
				//
				cp.setBodyValueAt(PayableBillItemVO.getQuantity_cr(),count, "quantity_cr");				
				//㷽ʽ
				cp.setBodyValueAt(PayableBillItemVO.getPk_balatype(),count, "pk_balatype");
				//ʲͬ
				cp.setBodyValueAt(PayableBillItemVO.getAssetpactno(),count, "assetpactno");
				//  ʽƻĿ
				cp.setBodyValueAt(PayableBillItemVO.getBankrollprojet(),count, "bankrollprojet");
				//  ݴ
				cp.setBodyValueAt(PayableBillItemVO.getBillclass(),count, "billclass");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBilldate(),count, "billdate");
				//  ݺ
				cp.setBodyValueAt(PayableBillItemVO.getBillno(),count, "billno");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBusidate(),count, "busidate");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getBuysellflag(),count, "buysellflag");
				//  ֽĿ
				cp.setBodyValueAt(PayableBillItemVO.getCashitem(),count, "cashitem");
				//  CBS
				cp.setBodyValueAt(PayableBillItemVO.getCbs(),count, "cbs");
				//  κҪ
				cp.setBodyValueAt(PayableBillItemVO.getCheckelement(),count, "checkelement");
				//  Ʊ
				cp.setBodyValueAt(PayableBillItemVO.getChecktype(),count, "checktype");
				//  ժҪc
				cp.setBodyValueAt(PayableBillItemVO.getComment(),count, "comment");
				//  ڲ׽
				cp.setBodyValueAt(PayableBillItemVO.getConfernum(),count, "confernum");
				//  ͬ
				cp.setBodyValueAt(PayableBillItemVO.getContractno(),count, "contractno");
				//  Эͬ״̬
				cp.setBodyValueAt(PayableBillItemVO.getCoordflag(),count, "coordflag");
				//  ɱ
				cp.setBodyValueAt(PayableBillItemVO.getCostcenter(),count, "costcenter");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getDirection(),count, "direction");
				//  豸
				cp.setBodyValueAt(PayableBillItemVO.getEquipmentcode(),count, "equipmentcode");
				//  ̶ʲƬ
				cp.setBodyValueAt(PayableBillItemVO.getFacard(),count, "facard");
				//  ɢ
				cp.setBodyValueAt(PayableBillItemVO.getFreecust(),count, "freecust");
				//  ȫֱ
				cp.setBodyValueAt(PayableBillItemVO.getGlobalbalance(),count, "globalbalance");
				//  ȫֱҽ()
				cp.setBodyValueAt(PayableBillItemVO.getGlobalcrebit(),count, "globalcrebit");
				//  ȫֱ˰()
				cp.setBodyValueAt(PayableBillItemVO.getGlobalnotax_cre(),count, "globalnotax_cre");
				//  ȫֱһ
				cp.setBodyValueAt(PayableBillItemVO.getGlobalrate(),count, "globalrate");
				//  ű
				cp.setBodyValueAt(PayableBillItemVO.getGroupbalance(),count, "groupbalance");
				//  űҽ()
				cp.setBodyValueAt(PayableBillItemVO.getGroupcrebit(),count, "groupcrebit");
				//  ű˰()
				cp.setBodyValueAt(PayableBillItemVO.getGroupnotax_cre(),count, "groupnotax_cre");
				//  űһ
				cp.setBodyValueAt(PayableBillItemVO.getGrouprate(),count, "grouprate");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getInnerorderno(),count, "innerorderno");
				//  Ʊ
				cp.setBodyValueAt(PayableBillItemVO.getInvoiceno(),count, "invoiceno");
				//  ɵֿ˰
				cp.setBodyValueAt(PayableBillItemVO.getNosubtax(),count, "nosubtax");
				//  ɵֿ˰
				cp.setBodyValueAt(PayableBillItemVO.getNosubtaxrate(),count, "nosubtaxrate");
				//  Ƿ˰
				cp.setBodyValueAt(PayableBillItemVO.getOpptaxflag(),count, "opptaxflag");
				//  Ӧ
				cp.setBodyValueAt(PayableBillItemVO.getOrdercubasdoc(),count, "ordercubasdoc");
				//  ⵥ
				cp.setBodyValueAt(PayableBillItemVO.getOutstoreno(),count, "outstoreno");
				//  ־
				cp.setBodyValueAt(PayableBillItemVO.getPausetransact(),count, "pausetransact");
				//  ˻
				cp.setBodyValueAt(PayableBillItemVO.getPayaccount(),count, "payaccount");
				//  ͱ
				cp.setBodyValueAt(PayableBillItemVO.getPk_billtype(),count, "pk_billtype");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_currtype(),count, "pk_currtype");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_deptid(),count, "pk_deptid");
				//   
				cp.setBodyValueAt(PayableBillItemVO.getPk_deptid_v(),count, "pk_deptid_v");
				//  ֯
				cp.setBodyValueAt(PayableBillItemVO.getPk_fiorg(),count, "pk_fiorg");
				//  ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_fiorg_v(),count, "pk_fiorg_v");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_group(),count, "pk_group");
				//  Ӧ֯
				cp.setBodyValueAt(PayableBillItemVO.getPk_org(),count, "pk_org");
				//  Ӧ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_org_v(),count, "pk_org_v");
				//  ӦӦʶ
				cp.setBodyValueAt(PayableBillItemVO.getPk_payablebill(),count, "pk_payablebill");
				//  Э
				cp.setBodyValueAt(PayableBillItemVO.getPk_payterm(),count, "pk_payterm");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_pcorg(),count, "pk_pcorgz");
				//  İ汾
				cp.setBodyValueAt(PayableBillItemVO.getPk_pcorg_v(),count, "pk_pcorg_v");
				//  ҵԱ
				cp.setBodyValueAt(PayableBillItemVO.getPk_psndoc(),count, "pk_psndoc");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPk_ssitem(),count, "pk_ssitem");
				//  Ӧcode
				cp.setBodyValueAt(PayableBillItemVO.getPk_tradetype(),count, "pk_tradetype");
				//  Ӧ
				cp.setBodyValueAt(PayableBillItemVO.getPk_tradetypeid(),count, "pk_tradetypeid");
				//  ۵λ˰
				cp.setBodyValueAt(PayableBillItemVO.getPostprice(),count, "postprice");
				//  ۵λ˰
				cp.setBodyValueAt(PayableBillItemVO.getPostpricenotax(),count, "postpricenotax");
				//  ۵λ
				cp.setBodyValueAt(PayableBillItemVO.getPostquantity(),count, "postquantity");
				//  ۼλ
				cp.setBodyValueAt(PayableBillItemVO.getPostunit(),count, "postunit");
				//  Ʒ
				cp.setBodyValueAt(PayableBillItemVO.getProductline(),count, "productline");
				//  Ŀ
				cp.setBodyValueAt(PayableBillItemVO.getProject_task(),count, "project_task");
				//  ҵ
				cp.setBodyValueAt(PayableBillItemVO.getPu_deptid(),count, "pu_deptid");
				//  ҵŰ汾
				cp.setBodyValueAt(PayableBillItemVO.getPu_deptid_v(),count, "pu_deptid_v");
				//  ҵ֯
				cp.setBodyValueAt(PayableBillItemVO.getPu_org(),count, "pu_org");
				//  ҵ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getPu_org_v(),count, "pu_org_v");
				//  ҵԱ
				cp.setBodyValueAt(PayableBillItemVO.getPu_psndoc(),count, "pu_psndoc");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getPurchaseorder(),count, "purchaseorder");
				//  ֯һ
				cp.setBodyValueAt(PayableBillItemVO.getRate(),count, "rate");
				//  տ˻
				cp.setBodyValueAt(PayableBillItemVO.getRecaccount(),count, "recaccount");
				//  ݷ¼
				cp.setBodyValueAt(i-1,count, "rowno");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getRowtype(),count, "rowtype");
				//  ժҪ
				cp.setBodyValueAt(PayableBillItemVO.getScomment(),count, "scomment");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSendcountryid(),count, "sendcountryid");
				//  ֯
				cp.setBodyValueAt(PayableBillItemVO.getSett_org(),count, "sett_org");
				//  ֯汾
				cp.setBodyValueAt(PayableBillItemVO.getSett_org_v(),count, "sett_org_v");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSettlecurr(),count, "settlecurr");
				//  
				cp.setBodyValueAt(PayableBillItemVO.getSettlemoney(),count, "settlemoney");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_billid(),count, "src_billid");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_billtype(),count, "src_billtype");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_itemid(),count, "src_itemid");
				//  Դͷ
				cp.setBodyValueAt(PayableBillItemVO.getSrc_tradetype(),count, "src_tradetype");
				//  Ŀ
				cp.setBodyValueAt(PayableBillItemVO.getSubjcode(),count, "subjcode");
				//  ˰
				cp.setBodyValueAt(PayableBillItemVO.getTaxnum(),count, "taxnum");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_billid(),count, "top_billid");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_billtype(),count, "top_billtype");
				//  ӽʱ
				cp.setBodyValueAt(PayableBillItemVO.getTop_changets(),count, "top_changets");
				//  ϲ㵥
				cp.setBodyValueAt(PayableBillItemVO.getTop_itemid(),count, "top_itemid");
				//  ϲ㽻
				cp.setBodyValueAt(PayableBillItemVO.getTop_tradetype(),count, "top_tradetype");
				//  VATע
				cp.setBodyValueAt(PayableBillItemVO.getVatcode(),count, "vatcode");
				//  ӦVATע
				cp.setBodyValueAt(PayableBillItemVO.getVendorvatcode(),count, "vendorvatcode");
				//Զ1-60
				cp.setBodyValueAt(PayableBillItemVO.getDef1(),count,"def1");
				cp.setBodyValueAt(PayableBillItemVO.getDef3(),count,"def3");
				cp.setBodyValueAt(PayableBillItemVO.getDef4(),count,"def4");
				cp.setBodyValueAt(PayableBillItemVO.getDef5(), count,"def5");
				cp.setBodyValueAt(PayableBillItemVO.getDef8(),count,"def8");
				cp.setBodyValueAt(PayableBillItemVO.getDef9(),count,"def9");
				cp.setBodyValueAt(PayableBillItemVO.getDef10(),count,"def10");
				cp.setBodyValueAt(PayableBillItemVO.getDef11(),count,"def11");
				cp.setBodyValueAt(PayableBillItemVO.getDef13(),count,"def13");
				cp.setBodyValueAt(PayableBillItemVO.getDef14(),count,"def14");
				cp.setBodyValueAt(PayableBillItemVO.getDef15(),count,"def15");
				cp.setBodyValueAt(PayableBillItemVO.getDef16(),count,"def16");
				cp.setBodyValueAt(PayableBillItemVO.getDef17(),count,"def17");
				cp.setBodyValueAt(PayableBillItemVO.getDef19(),count,"def19");
				cp.setBodyValueAt(PayableBillItemVO.getDef20(),count,"def20");
				cp.setBodyValueAt(PayableBillItemVO.getDef21(),count,"def21");
				cp.setBodyValueAt(PayableBillItemVO.getDef22(),count,"def23");
				cp.setBodyValueAt(PayableBillItemVO.getDef24(),count,"def24");
				cp.setBodyValueAt(PayableBillItemVO.getDef26(),count,"def26");
				cp.setBodyValueAt(PayableBillItemVO.getDef27(),count,"def27");
				cp.setBodyValueAt(PayableBillItemVO.getDef28(),count,"def28");
				cp.setBodyValueAt(PayableBillItemVO.getDef29(),count,"def29");
				cp.setBodyValueAt(PayableBillItemVO.getDef31(),count,"def31");
				cp.setBodyValueAt(PayableBillItemVO.getDef32(),count,"def32");
				cp.setBodyValueAt(PayableBillItemVO.getDef33(),count,"def33");
				cp.setBodyValueAt(PayableBillItemVO.getDef34(),count,"def34");
				cp.setBodyValueAt(PayableBillItemVO.getDef35(),count,"def35");
				cp.setBodyValueAt(PayableBillItemVO.getDef36(),count,"def36");
				cp.setBodyValueAt(PayableBillItemVO.getDef37(),count,"def37");
				cp.setBodyValueAt(PayableBillItemVO.getDef38(),count,"def38");
				cp.setBodyValueAt(PayableBillItemVO.getDef39(),count,"def39");
				cp.setBodyValueAt(PayableBillItemVO.getDef40(),count,"def40");
				cp.setBodyValueAt(PayableBillItemVO.getDef41(),count,"def41");
				cp.setBodyValueAt(PayableBillItemVO.getDef42(),count,"def42");
				cp.setBodyValueAt(PayableBillItemVO.getDef43(),count,"def43");
				cp.setBodyValueAt(PayableBillItemVO.getDef44(),count,"def44");
				cp.setBodyValueAt(PayableBillItemVO.getDef45(),count,"def45");
				cp.setBodyValueAt(PayableBillItemVO.getDef46(),count,"def46");
				cp.setBodyValueAt(PayableBillItemVO.getDef47(),count,"def47");
				cp.setBodyValueAt(PayableBillItemVO.getDef48(),count,"def48");
				cp.setBodyValueAt(PayableBillItemVO.getDef49(),count,"def49");
				cp.setBodyValueAt(PayableBillItemVO.getDef50(),count,"def50");
				cp.setBodyValueAt(PayableBillItemVO.getDef51(),count,"def51");
				cp.setBodyValueAt(PayableBillItemVO.getDef52(),count,"def52");
				cp.setBodyValueAt(PayableBillItemVO.getDef53(),count,"def53");
				cp.setBodyValueAt(PayableBillItemVO.getDef54(),count,"def54");
				cp.setBodyValueAt(PayableBillItemVO.getDef55(),count,"def55");
				cp.setBodyValueAt(PayableBillItemVO.getDef56(),count,"def56");
				cp.setBodyValueAt(PayableBillItemVO.getDef57(),count,"def57");
				cp.setBodyValueAt(PayableBillItemVO.getDef58(),count,"def58");
				cp.setBodyValueAt(PayableBillItemVO.getDef59(),count,"def59");
				cp.setBodyValueAt(PayableBillItemVO.getDef60(),count,"def60");
			}
		}
		//ѭɾ
		for(int j = 0;j<rowCount;j++){
			cp.getBillModel().delLine(new int[] {0});
		}
		//pkתʾı	
		BillModel tableModel = importBodyAction.editorModel.getBillCardPanel().getBodyPanel().getTableModel();
		tableModel.loadLoadRelationItemValue();
		/*
		 * def1Ǹգpk_subjcodeд˸༭ʽcodeֵdef1,ֻ˵6,뵼def1
		ᵼdef1ֵΪգΪcodeƥ䲻Ӧname,ֻٴεñ༭ʽֵ
		 */

		//ȡıѭñ༭ʽ
		int rowCounts = cp.getRowCount();
		for (int x = 0; x < rowCounts; x++) {
			importBodyAction.editorModel.getBillCardPanel().getBillModel().execEditFormulasByKey(x, "pk_subjcode");
		}
	}
	
	/*
	 *	жϱͷ
	 */
	private  void importHendBeforCheck(BillCardPanel cp,String type) throws Exception {
		if("ӦĿ".equals(type)) {
			Object 	def3 = cp.getHeadItem("def3").getValueObject();
			if(def3 == null){
				throw new Exception("дͷ鸶ڣ");
			}
			Object 	def5 = cp.getHeadItem("def5").getValueObject();
			if(def5 == null){
				throw new Exception("дͷóеţ");
			}
			Object 	def20 = cp.getHeadItem("def20").getValueObject();
			if(def20 == null){
				throw new Exception("дͷԤڲţ");
			}
			Object supplier = cp.getHeadItem("supplier").getValueObject();
			if(supplier == null){
				throw new Exception("дͷԷλƣ");
			}
			Object recaccount = cp.getHeadItem("recaccount").getValueObject();
			if(recaccount == null){
				throw new Exception("дͷԷ˻");
			}
		}else if("ӦĿ".equals(type)){
			Object 	def3 = cp.getHeadItem("def3").getValueObject();
			if(def3 == null){
				throw new Exception("дͷ鸶ڣ");
			}
			Object 	def5 = cp.getHeadItem("def5").getValueObject();
			if(def5 == null){
				throw new Exception("дͷóеţ");
			}
		}else if("ԤĿ".equals(type)){
			Object 	def5 = cp.getHeadItem("def5").getValueObject();
			if(def5 == null){
				throw new Exception("дͷóеţ");
			}
			Object 	def20 = cp.getHeadItem("def20").getValueObject();
			if(def20 == null){
				throw new Exception("дͷԤڲţ");
			}
		}else {
			Object 	def5 = cp.getHeadItem("def5").getValueObject();
			if(def5 == null){
				throw new Exception("дͷóеţ");
			}
		}
	}
	
	
	
	/*
	 * жϱ
	 */
	private void importBodyBeforCheck(HSSFSheet sheet, String type, int rowNum) throws Exception {
		for (int i = 2; i < rowNum; i++) {
			int[] index = null;
			if("ӦĿ".equals(type)) {
				//ҪУExcle±
				index = new int[]{0,1,2,3,4,5,6,7,8,10,11,12,20,21};
			}else if("ӦĿ".equals(type)){
				//ҪУExcle±
				index = new int[]{0,1,2,3,4,5,6,7,8,9,10,12,13,15,17,20,21};
			}else if("ԤĿ".equals(type)){
				//ҪУExcle±
				index = new int[]{0,1,2,3,4,5,6,7,9,10,11,12,13,14,16,17,18};
			}else {
				//ҪУExcle±
				index = new int[]{0,1,2,3,4,5,6,7,8,9,11,12,13,14,15,16,17,19,20};
			}
			for (int j = 0; j < index.length; j++) {
				if(sheet.getRow(i).getCell(index[j])!= null) {
					if(sheet.getRow(i).getCell(index[j]).getCellType() == 3) {
						throw new Exception("*ΪȷϺе룡Excle");
					}else {
						Object value = sheet.getRow(i).getCell(index[j]).getCellType() == 1 ? sheet.getRow(i).getCell(index[j]).getStringCellValue() : sheet.getRow(i).getCell(index[j]).getNumericCellValue();
						if(value == null || "".equals(value)) {
							throw new Exception("*ΪȷϺе룡Excle");
						}
					}
					
				}else {
					throw new Exception("*ΪȷϺе룡Excle");
				}
			}
		}
	}
	
	/*
	 * ݴ
	 */
	private Object dateUnit(HSSFSheet sheet, int i, int j) {
		if(sheet.getRow(i).getCell(j) == null) {
			return null;
		}else {
			//3ʾַ
			if(sheet.getRow(i).getCell(j).getCellType() == 3) {
				return null;
			}else {
				return sheet.getRow(i).getCell(j).getCellType() == 1 ? sheet.getRow(i).getCell(j).getStringCellValue() : sheet.getRow(i).getCell(j).getNumericCellValue();
			}	
		}
	}
	
	
	/*
	 * ݿѯ
	 */
	private String sqlexecuteQuery(String out,String table,String key,String value,String pk_org,int enablestate) throws Exception {
		StringBuffer sql = new StringBuffer();
		sql.append("select "+out+" from "+table+" where "+key+" = '"+value+"' and nvl(dr,0) = 0");
		if(pk_org != null) {
			sql.append(" and pk_org = '"+pk_org+"'");
		}
		if(enablestate == 2) {
			sql.append(" and enablestate = 2");
		}
		
		Object object;
		object = iuap.executeQuery(sql.toString(), new ColumnProcessor());
		if (object == null) {
			throw new Exception("ݷʧܣֵ:"+value);
		}
		return object.toString();
	}
	/*
	 * ݿѯԶ嵵
	 */
	private String sqlexecuteQueryDoc(String name,String code) throws Exception {
		String sql = "select  pk_defdoc from bd_defdoc where name = '"+name+"' and pk_defdoclist = (select pk_defdoclist from bd_defdoclist where code ='"+code+"') ";
		
		Object object;
			object = iuap.executeQuery(sql, new ColumnProcessor());
			if (object == null) {
				throw new Exception("ݷʧܣֵ:"+name);
			}
			return object.toString();
	}
	
	/*
	 * ݲɹƱƱŲѯӦк
	 */
	private  PayableBillItemVO queryBillItem(String billno,String vbillcode) throws Exception {
		String sql = "select * from ap_payableitem where def12 = '"+vbillcode+"' and pk_payablebill = (select pk_payablebill from ap_payablebill where billno = '"+billno+"'and nvl( dr, 0 ) = 0) and nvl( dr, 0 ) = 0";
		PayableBillItemVO payableBillItemVO = (PayableBillItemVO) iuap.executeQuery(sql, new BeanProcessor(PayableBillItemVO.class));
		if(payableBillItemVO == null){
			throw new Exception("鷢ƱǷȷ");
		}
		return payableBillItemVO;

	}
}
