package nc.impl.th;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;


import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.pu.plugin.DataUtils.QueryDataUtil;
import nc.bs.scmpub.pf.PfParameterUtil;
import nc.bs.servlet.service.BaseServlet;
import nc.itf.pu.m21.IOrderApprove;
import nc.itf.pu.m21.IOrderMaintain;
import nc.itf.uap.pf.IPFBusiAction;
import nc.itf.uap.pf.IWorkflowMachine;
import nc.log.NcLog;
import nc.vo.bd.material.MaterialVO;
import nc.vo.ct.purdaily.entity.CtPuBVO;
import nc.vo.org.PurchaseOrgVO;
import nc.vo.pu.m21.entity.OrderHeaderVO;
import nc.vo.pu.m21.entity.OrderItemVO;
import nc.vo.pu.m21.entity.OrderVO;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.workflownote.WorkflownoteVO;
import nc.vo.util.CloneUtil;

public class OrderAddImpl extends BaseServlet implements IHttpServletAdaptor {

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		String vbillcode = "";
		try {
			NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(),"pfxx".getBytes());
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSON.parseObject(createStr);
			NcLog.info(json.toString());
			vbillcode = json.getString("vbillcode");
			//InvocationInfoProxy.getInstance().setUserDataSource("NC6337");
			QueryDataUtil.getBillno(vbillcode);
			checkJson(json);
			OrderVO orderVO = new OrderVO();
			OrderHeaderVO orderHeaderVO = new OrderHeaderVO();
			String userPK = QueryDataUtil.getUserPK(json.getString("billmaker"));
			String pk_group = QueryDataUtil.getGroupPK(json.getString("pk_group"));

			InvocationInfoProxy.getInstance().setUserId(userPK);//û
			InvocationInfoProxy.getInstance().setGroupId(pk_group);//ָpk
			//Ƶ
			orderHeaderVO.setBillmaker(userPK);
			//˼Ƶ
			orderHeaderVO.setApprover(userPK);
			//
			orderHeaderVO.setCorigcurrencyid(QueryDataUtil.getCurrtypePK(json.getString("corigcurrencyid")));
			//
			orderHeaderVO.setCtrantypeid(QueryDataUtil.getBilltypePK(json.getString("vtrantypecode")));
			//
			orderHeaderVO.setDbilldate(new UFDate(json.getString("dbilldate")));
			//Ƶ
			orderHeaderVO.setDmakedate(new UFDate(json.getString("dmakedate")));
			//ڼƵʱ
			orderHeaderVO.setTaudittime(orderHeaderVO.getDmakedate());
			//˰
			orderHeaderVO.setFhtaxtypeflag(Integer.parseInt(json.getString("fhtaxtypeflag")));
			//
			orderHeaderVO.setNtotalastnum(new UFDouble(json.getString("ntotalastnum")));
			//˰ϼ
			orderHeaderVO.setNtotalorigmny(new UFDouble(json.getString("ntotalorigmny")));
			//ҵ
			orderHeaderVO.setPk_busitype(QueryDataUtil.getBusitypePK(json.getString("pk_busitype")));
			//ɹԱ-ƻԱ
			orderHeaderVO.setCemployeeid(QueryDataUtil.getPsndocPK(json.getString("cemployeeid")));
			//ɹ°汾-ƻ
			orderHeaderVO.setPk_dept(QueryDataUtil.getDeptVPK(json.getString("pk_dept")));
			//ɹ-ƻ
			orderHeaderVO.setPk_dept_v(orderHeaderVO.getPk_dept());
			//
			orderHeaderVO.setPk_group(pk_group);
			//ƱӦ
			orderHeaderVO.setPk_invcsupllier(QueryDataUtil.getSupplierPK(json.getString("pk_invcsupllier")));
			//Ӧ
			orderHeaderVO.setPk_supplier(orderHeaderVO.getPk_invcsupllier());
			//
			orderHeaderVO.setPk_bankdoc(QueryDataUtil.getBankaccsubPK(json.getString("payaccount"),orderHeaderVO.getPk_invcsupllier()));
			PurchaseOrgVO purchaseOrgVO = QueryDataUtil.getFinanceOrgVO(json.getString("pk_org"));
			//ɹ֯汾
			orderHeaderVO.setPk_org(purchaseOrgVO.getPk_purchaseorg());
			//ɹ֯
			orderHeaderVO.setPk_org_v(purchaseOrgVO.getPk_vid());
			//
			orderHeaderVO.setVbillcode(vbillcode);
			//ע
			orderHeaderVO.setVmemo(json.getString("vmemo"));
			//
			orderHeaderVO.setVtrantypecode(json.getString("vtrantypecode"));
			//ǷҪͶ
			orderHeaderVO.setVdef2(QueryDataUtil.getDefdocPK(json.getString("vdef2"), "11", "ǷҪͶ"));
			//޿Э
			orderHeaderVO.setVdef3(QueryDataUtil.getDefdocPK(json.getString("vdef3"), "12", "޿Э"));
			//Ԥ
			orderHeaderVO.setVdef5(QueryDataUtil.getInoutbusiclassPK(json.getString("vdef5")));
			//Ԥ
			orderHeaderVO.setVdef9(json.getString("vdef5"));
			//ƻ
			orderHeaderVO.setVdef6(json.getString("vdef6"));
			//Ԥڲ
			orderHeaderVO.setVdef7(QueryDataUtil.getDeptPK(json.getString("vdef7")));
			//Ӧ̿
			orderHeaderVO.setVdef8(QueryDataUtil.getBankdocName(json.getString("payaccount"),orderHeaderVO.getPk_invcsupllier()));
			//Ƿи
			orderHeaderVO.setVdef10(QueryDataUtil.getDefdocPK(json.getString("vdef10"), "18", "Ƿи"));
			//ջ
			orderHeaderVO.setVdef15(QueryDataUtil.getPsndocPK(json.getString("vdef15")));
			//ջϵ绰
			orderHeaderVO.setVdef16(json.getString("vdef16"));
			//ջַ
			orderHeaderVO.setVdef17(QueryDataUtil.getDefdocPK(json.getString("vdef17"), "shdz", "ջַ"));
			//ɹԱ
			orderHeaderVO.setVdef18(QueryDataUtil.getPsndocPK(json.getString("vdef18")));
			//ɹ
			orderHeaderVO.setVdef19(QueryDataUtil.getDeptPK(json.getString("vdef19")));
			orderHeaderVO.setStatus(2);
			orderHeaderVO.setForderstatus(3);
			orderVO.setParent(orderHeaderVO);
			JSONArray josns = json.getJSONArray("childrenVO");
			List<OrderItemVO> listOrderItemVO = new ArrayList<OrderItemVO>();
			for (int i = 0; i < josns.size(); i++) {
				JSONObject item = josns.getJSONObject(i);
				OrderItemVO orderItemVO = new OrderItemVO();
				
				//к
				orderItemVO.setCrowno(item.getString("crowno"));
				String vcontractcode = item.getString("vcontractcode");
				Map<String,String> map = new HashMap<String,String>();
				if(!"".equals(vcontractcode)) {
					
					map = QueryDataUtil.getDataMap("Z2", vcontractcode, item.getString("vcontractcrowno"));
					//ͬ
					orderItemVO.setVcontractcode(vcontractcode);
					//ͬ
					orderItemVO.setCcontractid(map.get("pk_id"));
					//ͬ
					orderItemVO.setCcontractrowid(map.get("pk_id_b"));
				}
				//ұ
				orderItemVO.setCcurrencyid(QueryDataUtil.getCurrtypePK(item.getString("ccurrencyid")));
				//
				orderItemVO.setCorigcurrencyid(orderItemVO.getCcurrencyid());
				
				String vfirstcode = item.getString("vfirstcode");
				if(!"".equals(vfirstcode)) {
					String cfirsttypecode = item.getString("cfirsttypecode");
					String vfirstrowno = item.getString("vfirstrowno");
					map = QueryDataUtil.getDataMap(cfirsttypecode, vfirstcode, vfirstrowno);
					//Դͷݺ
					orderItemVO.setVfirstcode(vfirstcode);
					//Դͷ
					orderItemVO.setCfirstid(map.get("pk_id"));
					//Դͷϸ
					orderItemVO.setCfirstbid(map.get("pk_id_b"));
					//Դͷк
					orderItemVO.setVfirstrowno(vfirstrowno);
					//Դͷ
					orderItemVO.setVfirsttrantype(QueryDataUtil.getBilltypePK(item.getString("vfirsttrantype")));
					//Դͷ
					orderItemVO.setCfirsttypecode(QueryDataUtil.getBilltypePK(cfirsttypecode));
				}
				
				String vsourcecode = item.getString("vsourcecode");
				if(!"".equals(vsourcecode)) {
					String vsourcerowno = item.getString("vsourcerowno");
					String csourcetypecode = item.getString("csourcetypecode");
					map = QueryDataUtil.getDataMap(csourcetypecode, vsourcecode, vsourcerowno);
					//Դݺ 
					orderItemVO.setVsourcecode(vsourcecode);
					//Դк
					orderItemVO.setVsourcerowno(vsourcerowno);
					//Դ
					orderItemVO.setVsourcetrantype(QueryDataUtil.getBilltypePK(item.getString("vsourcetrantype")));
					//Դ
					orderItemVO.setCsourceid(map.get("pk_id"));
					//Դϸ
					orderItemVO.setCsourcebid(map.get("pk_id_b"));
					//Դ
					orderItemVO.setCsourcetypecode(QueryDataUtil.getBilltypePK(csourcetypecode));
				}
				//˰
				orderItemVO.setCtaxcodeid(QueryDataUtil.getTaxcodePK(item.getString("ctaxcodeid")));
				//˰
				orderItemVO.setNtaxrate(new UFDouble(item.getString("ntaxrate")));
				//λ
				orderItemVO.setCunitid(QueryDataUtil.getMeasdocPK(item.getString("cunitid")));
				//λ
				orderItemVO.setCastunitid(orderItemVO.getCunitid());
				//۵λ
				orderItemVO.setCqtunitid(orderItemVO.getCunitid());
				//
				orderItemVO.setDbilldate(orderHeaderVO.getDbilldate());
				//ƻ
				orderItemVO.setDplanarrvdate(orderHeaderVO.getDbilldate());
				//
				orderItemVO.setFbuysellflag(Integer.parseInt(item.getString("fbuysellflag")));
				//˰
				orderItemVO.setFtaxtypeflag(orderHeaderVO.getFhtaxtypeflag());
				//˰
				orderItemVO.setNcaltaxmny(new UFDouble(item.getString("ncaltaxmny")));
				//Ƴɱ
				orderItemVO.setNcalcostmny(orderItemVO.getNcaltaxmny());
				//۱
				orderItemVO.setNexchangerate(new UFDouble(1));
				//ۿ
				orderItemVO.setNitemdiscountrate(new UFDouble(100));
				
				//
				orderItemVO.setNnum(new UFDouble(item.getString("nnum")));
				//
				orderItemVO.setNastnum(orderItemVO.getNnum());
				//
				orderItemVO.setNqtunitnum(orderItemVO.getNnum());
				
				//˰
				orderItemVO.setNqtorigprice(new UFDouble(item.getString("nqtorigprice")));
				//˰ 
				orderItemVO.setNqtorignetprice(orderItemVO.getNqtorigprice());
				//˰
				orderItemVO.setNorigprice(orderItemVO.getNqtorigprice());
				//˰
				orderItemVO.setNorignetprice(orderItemVO.getNqtorigprice());
				//˰
				orderItemVO.setNqtprice(orderItemVO.getNqtorigprice());
				//˰
				orderItemVO.setNqtnetprice(orderItemVO.getNqtorigprice());
				//˰
				orderItemVO.setNprice(orderItemVO.getNqtorigprice());
				//˰
				orderItemVO.setNnetprice(orderItemVO.getNqtorigprice());
				//˰ 
				orderItemVO.setNqtorigtaxprice(new UFDouble(item.getString("nqtorigtaxprice")));
				//˰
				orderItemVO.setNqtorigtaxnetprc(orderItemVO.getNqtorigtaxprice());
				//˰
				orderItemVO.setNorigtaxprice(orderItemVO.getNqtorigtaxprice());
				//˰
				orderItemVO.setNorigtaxnetprice(orderItemVO.getNqtorigtaxprice());
				//Һ˰ 
				orderItemVO.setNqttaxprice(orderItemVO.getNqtorigtaxprice());
				//Һ˰
				orderItemVO.setNqttaxnetprice(orderItemVO.getNqtorigtaxprice());
				//Һ˰
				orderItemVO.setNtaxprice(orderItemVO.getNqtorigtaxprice());
				//Һ˰
				orderItemVO.setNtaxnetprice(orderItemVO.getNqtorigtaxprice());
				//˰
				orderItemVO.setNtax(new UFDouble(item.getString("ntax")));
				//˰
				orderItemVO.setNorigmny(new UFDouble(item.getString("norigmny")));
				//˰
				orderItemVO.setNmny(orderItemVO.getNorigmny());
				//˰ϼ
				orderItemVO.setNorigtaxmny(new UFDouble(item.getString("norigtaxmny")));
				//Ҽ˰ϼ
				orderItemVO.setNtaxmny(orderItemVO.getNorigtaxmny());
				//Ӧ֯°汾 
				orderItemVO.setPk_apfinanceorg(orderHeaderVO.getPk_org());
				//Ӧ֯
				orderItemVO.setPk_apfinanceorg_v(orderHeaderVO.getPk_org_v());
				//°汾 
				orderItemVO.setPk_apliabcenter(orderHeaderVO.getPk_org());
				//
				orderItemVO.setPk_apliabcenter_v(orderHeaderVO.getPk_org_v());
				//ջ֯°汾
				orderItemVO.setPk_arrvstoorg(orderHeaderVO.getPk_org());
				//ջ֯
				orderItemVO.setPk_arrvstoorg_v(orderHeaderVO.getPk_org_v());
				//ɹ֯汾Ϣ
				orderItemVO.setPk_org(orderHeaderVO.getPk_org());
				//ɹ֯
				orderItemVO.setPk_org_v(orderHeaderVO.getPk_org_v());
				//֯°汾
				orderItemVO.setPk_psfinanceorg(orderHeaderVO.getPk_org());
				//֯
				orderItemVO.setPk_psfinanceorg_v(orderHeaderVO.getPk_org_v());
				//˾ 
				orderItemVO.setPk_reqcorp(orderHeaderVO.getPk_org());
				//֯°汾
				orderItemVO.setPk_reqstoorg(orderHeaderVO.getPk_org());
				//֯
				orderItemVO.setPk_reqstoorg_v(orderHeaderVO.getPk_org_v());
				//°汾
				orderItemVO.setPk_reqdept(QueryDataUtil.getDeptPK(item.getString("pk_reqdept")));
				//
				orderItemVO.setPk_reqdept_v(QueryDataUtil.getDeptVPK(item.getString("pk_reqdept")));
				
				//
				orderItemVO.setPk_group(orderHeaderVO.getPk_group());
				MaterialVO materialVO = QueryDataUtil.getMaterialPK(item.getString("pk_material"));
				//ϰ汾Ϣ
				orderItemVO.setPk_material(materialVO.getPk_material());
				//Ϣ
				orderItemVO.setPk_srcmaterial(materialVO.getPk_source());
				//Ӧ
				orderItemVO.setPk_supplier(orderHeaderVO.getPk_supplier());
				//ע
				orderItemVO.setVbmemo(item.getString("vbmemo"));
				//
				orderItemVO.setVchangerate(item.getString("vchangerate"));
				//ۻ
				orderItemVO.setVqtunitrate(orderItemVO.getVchangerate());
				///
				orderItemVO.setCsendcountryid(QueryDataUtil.getCountryzonePK("CN"));
				//ջ/
				orderItemVO.setCrececountryid(orderItemVO.getCsendcountryid());
				//˰/
				orderItemVO.setCtaxcountryid(orderItemVO.getCsendcountryid());
				//õ
				orderItemVO.setVbdef4(item.getString("vbdef4"));
				//ɹ˰Ԥ
				orderItemVO.setVbdef5(item.getString("vbdef5"));
				//Աе
				orderItemVO.setVbdef7(item.getString("vbdef7"));
				//ʹ
				orderItemVO.setVbdef13(QueryDataUtil.getPsndocPK(item.getString("vbdef13")));
				orderItemVO.setStatus(2);
				listOrderItemVO.add(orderItemVO);
			}
			orderVO.setChildrenVO(listOrderItemVO.toArray(new OrderItemVO[listOrderItemVO.size()]));
			//߳ʱ
			SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			Object dateTimeString  = orderHeaderVO.getDbilldate();
			if(dateTimeString != null) {
			    Date date = format.parse(dateTimeString.toString());
			    long timestamp = date.getTime();
			    InvocationInfoProxy.getInstance().setBizDateTime(timestamp);
			 }
			IPFBusiAction ipf = NCLocator.getInstance().lookup(IPFBusiAction.class);
			OrderVO[] orderVOs = (OrderVO[]) ipf.processAction("SAVEBASE", "21", null, orderVO, null, null);
			
//			HashMap hmPfExParams = new HashMap();
//			WorkflownoteVO workflownoteVO = NCLocator.getInstance().lookup(IWorkflowMachine.class).checkWorkFlow("SAVE", "21", orderVOs[0], hmPfExParams);
//			if(workflownoteVO == null) { 
//				//û
//				ipf.processAction("APPROVE", "21", workflownoteVO, orderVOs[0], null, null);
//			}else {
//				ipf.processAction("SAVE", "21", workflownoteVO, orderVOs[0], null, null);
//			}
			
			resp.getWriter().write(formatRSJsonData("ɹ", "", vbillcode).toString());
		} catch (Exception e) {
			resp.getWriter().write(formatRSJsonData("ʧ",e.getMessage() == null ? "" : e.getMessage(),vbillcode).toString());
			StringWriter stringWriter = new StringWriter();
			e.printStackTrace(new PrintWriter(stringWriter));
			//ȡϸϢ
			String msg=stringWriter.getBuffer().toString();
			NcLog.info(msg);
		}
		
	}
	
	
	private void checkJson(JSONObject json) throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		
		String pk_group = "pk_group";
		String pk_org = "pk_org";
		String vbillcode = "vbillcode";
		String billmaker  = "billmaker";
		String cemployeeid = "cemployeeid";
		String corigcurrencyid = "corigcurrencyid";
		String dbilldate = "dbilldate";
		String dmakedate = "dmakedate";
		String fhtaxtypeflag = "fhtaxtypeflag";
		String ntotalastnum = "ntotalastnum";
		String ntotalorigmny = "ntotalorigmny";
		String pk_busitype = "pk_busitype";
		String pk_invcsupllier = "pk_invcsupllier";
		String vtrantypecode = "vtrantypecode";
		String vdef5 = "vdef5";
		String vdef7 = "vdef7";
		String vdef18 = "vdef18";
		String vdef19 = "vdef19";
		String body = "childrenVO";//
		String[] HeadKey = {pk_group,pk_org,vbillcode,billmaker,cemployeeid,corigcurrencyid,dbilldate,dmakedate,dmakedate,
				fhtaxtypeflag,ntotalastnum,ntotalorigmny,pk_busitype,pk_invcsupllier,vtrantypecode,vdef5,vdef7,vdef18,vdef19};
		
		for (String as : HeadKey) {

			if (json.getString(as).isEmpty()) {
				empty = false;
				mags.append("'" + as + "'");
			}
		}
		if (json.getJSONArray(body)==null) {
			empty = false;
			mags.append("岻ڣ ");
		}
		
		JSONArray childrenVO = json.getJSONArray("childrenVO");
		
		if (childrenVO == null || childrenVO.size() == 0) {
			throw new Exception("ݲΪգ");
		}
		

		String rowno = "crowno";
		String ccurrencyid = "ccurrencyid";
		String ctaxcodeid = "ctaxcodeid";
		String ntaxrate = "ntaxrate";
		String cunitid = "cunitid";
		String fbuysellflag = "fbuysellflag";
		String ncaltaxmny = "ncaltaxmny";
		String nnum = "nnum";
		String nqtorigprice = "nqtorigprice";
		String nqtorigtaxprice = "nqtorigtaxprice";
		String ntax = "ntax";
		String norigmny = "norigmny";
		String norigtaxmny = "norigtaxmny";
		String pk_material = "pk_material";
		String vchangerate = "vchangerate";
		String vbdef7 = "vbdef7";

		for(int i = 0; i < childrenVO.size(); i++) {
			
			JSONObject oprepJsonObjectB = childrenVO.getJSONObject(i);
			String[] BodyKey = {rowno,ccurrencyid,ctaxcodeid,ntaxrate,cunitid,fbuysellflag,ncaltaxmny,nnum,nqtorigprice,
					nqtorigtaxprice,ntax,norigmny,norigtaxmny,pk_material,vchangerate,vbdef7};
			int num = i+1;
			
			mags.append(""+num+"壺{");
			for (String as : BodyKey) {
				if (oprepJsonObjectB.getString(as).isEmpty()) {
					empty = false;
					mags.append("'" + as + "' ");
				}
			}
			mags.append("}");
		}
		if (!empty) {
			throw new Exception("ֶβΪգ"+mags);
		}
	}
}
